/* An example showing how to use FLP from Imagine V       */
/* Copyright 1996 by Software Industry & General Hardware */
/* ALL RIGHTS RESERVED                                    */
/* May be freely distributed without modification.        */
/* Written By: Clark Williams                             */
/* October 27, 1996                                       */

/*
TRACE ALL
TRACE RESULTS
*/

FALSE = 0
TRUE  = ~FALSE
Done  = FALSE

OPTIONS RESULTS

/* Make sure that the rexxsupport.library is available  */
IF ~SHOW('L',"rexxsupport.library") THEN DO
  IF ~ADDLIB('rexxsupport.library',0,-30,0) THEN DO
    SAY 'Fatal error: Unable To Load the rexxsupport.library'
    EXIT 20
  END
END
  
/* Attempt to find a funning FL_Panel or force one to Run */
ForcedRUn  = FALSE
StopTrying = FALSE

DO WHILE ~StopTrying & ~Done
  Done      = FALSE
  PortCount = 1

  /* Look for a FL_Panel Port */
  DO WHILE ~Done & PortCount < 10
    NextPortName = 'FL_PANEL_'||PortCount
    IF SHOW( 'P', NextPortName )
      THEN Done = TRUE
      ELSE PortCount = PortCount + 1
  END /* WHILE ~Done */

  IF ~Done THEN DO
     IF ~ForcedRun THEN DO
         ADDRESS COMMAND
         'RUN' '<NIL: >NIL: FL:FL-Panel/FL_Panel'
         SAY "RUN Netted: "RESULT
         ForcedRun = TRUE
        END
       ELSE StopTrying = TRUE
  END /* IF ~Done */
END /* WHILE ~StopTrying */

IF StopTrying THEN DO
   SAY "Could not find a running FL_Panel and could not start one."
   EXIT 25
END /* IF StopTrying */

SAY "Found FLP as " NextPortName

/* Make sure an Imagine is also running */
Done      = FALSE
PortCount = 1

DO WHILE ~Done & PortCount < 10
  NxtImaginePort = 'Imagine.'||PortCount
  IF SHOW( 'P', NxtImaginePort )
    THEN Done = TRUE
    ELSE PortCount = PortCount + 1

IF ~Done THEN DO
   SAY "Fatal error: Imagine port not found running."
   EXIT 26
END

SAY "Found Imagine port as " NxtImaginePort

ADDRESS NextPortName

/* We get here we can control FL_Panel */

ADDRESS VALUE NextPortName

NextPortName 'X' '20'
NextPortName 'Y' '15'
NextPortName 'Seed' '317'
NextPortName 'Randomize'
NextPortName 'Make'
NextPortName 'QUIT'

EXIT 0
