/*----------------------------------------------------------------------------*
 *                                                                            *
 *  AGA-Morph-Gadgets.c V1.2                                                  *
 *                                                                            *
 *----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------*/

#include <libraries/diskfont.h>
#include <intuition/intuition.h>
#include <intuition/classes.h>
#include <intuition/pointerclass.h>
#include <datatypes/pictureclass.h>
#include <datatypes/pictureclassext.h>
#include <graphics/gfx.h>
#include <exec/memory.h>
#include <libraries/asl.h>
#include <clib/macros.h>

#include "AGA-Morph-Language.h"

/*----------------------------------------------------------------------------*/

extern struct TextAttr NormalFont;

/*----------------------------------------------------------------------------*/

UWORD CrossPlanes[]={0x0020,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x7f8f,0xf000,
                     0xff9f,0xf000,
                     0x0020,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0060,0x0000,
                     0x0000,0x0000,

                     0x0020,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x7faf,0xf000,
                     0x8050,0x0800,
                     0x7faf,0xf000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0050,0x0000,
                     0x0020,0x0000};

UWORD ArrowPlanes[]={0xc000,0x0000,
                     0x7000,0x0000,
                     0x3c00,0x0000,
                     0x3f00,0x0000,
                     0x1fc0,0x0000,
                     0x1ff0,0x0000,
                     0x0ffc,0x0000,
                     0x0fff,0x0000,
                     0x07ff,0xc000,
                     0x07ff,0xf000,
                     0x03ff,0xf000,
                     0x03f8,0x0000,
                     0x01ec,0x0000,
                     0x01e6,0x0000,
                     0x00e3,0x0000,
                     0x00e1,0x8000,
                     0x0060,0xc000,
                     0x0060,0x6000,
                     0x0020,0x3000,
                     0x0020,0x1000,

                     0x4000,0x0000,
                     0xb000,0x0000,
                     0x4c00,0x0000,
                     0x4300,0x0000,
                     0x20c0,0x0000,
                     0x2030,0x0000,
                     0x100c,0x0000,
                     0x1003,0x0000,
                     0x0800,0xc000,
                     0x0800,0x3000,
                     0x0400,0x0000,
                     0x0408,0x0000,
                     0x0214,0x0000,
                     0x020a,0x0000,
                     0x0105,0x0000,
                     0x0102,0x8000,
                     0x0081,0x4000,
                     0x0080,0xa000,
                     0x0040,0x5000,
                     0x0040,0x2000,};

UWORD *Slider;
UWORD *RadioOn;
UWORD *RadioOff;
UWORD *Info;

/*----------------------------------------------------------------------------*/

UBYTE PointsBBuf[15]={48,0,0,0,0,48,0,0,0,0,48,0,0,0,0};
UBYTE DPicYBuf[15]={48+2,48+5,48+6,0,0,48+2,48+5,48+6,0,0,48+2,48+5,48+6,0,0};
UBYTE DPicXBuf[15]={48+3,48+2,48,0,0,48+3,48+2,48,0,0,48+3,48+2,48,0,0};
UBYTE Poi2ValBuf[12]={48,0,0,0,48,0,0,0,48,0,0,0};
UBYTE Pic2ValBuf[12]={48,0,0,0,48,0,0,0,48,0,0,0};

/*----------------------------------------------------------------------------*/

struct BitMap CrossBMP={4,21,0,2,0,(PLANEPTR) &CrossPlanes[0],(PLANEPTR) &CrossPlanes[42]};
struct BitMap ArrowBMP={4,20,0,2,0,(PLANEPTR) &ArrowPlanes[0],(PLANEPTR) &ArrowPlanes[40]};

/*----------------------------------------------------------------------------*/

struct Image Pic2Slider1r=
{
  0,0,
  46,10,
  2,
  0,
  3,0,
  0
};

struct Image Poi2Slider1r=
{
  0,0,
  46,10,
  2,
  0,
  3,0,
  0
};

struct Image RadioOnIm=
{
  0,0,
  20,14,
  2,
  0,
  3,0,
  0
};

struct Image RadioOffIm=
{
  0,0,
  20,14,
  2,
  0,
  3,0,
  0
};

struct Image ViewWindowBar2r;

struct Image ViewWindowBar1r;

struct Image EditWindowBar2r;

struct Image EditWindowBar1r;

struct Image ButtonIm1=
{
  1,1,
  148,12,
  0,0,
  0,0,
  0
};

struct Image ButtonIm2=
{
  0,0,
  149,1,
  0,0,
  0,2,
  &ButtonIm1
};

struct Image ButtonIm3=
{
  0,1,
  1,13,
  0,0,
  0,2,
  &ButtonIm2
};

struct Image ButtonIm4=
{
  1,13,
  149,1,
  0,0,
  0,1,
  &ButtonIm3
};

struct Image ButtonIm=
{
  149,1,
  1,13,
  0,0,
  0,1,
  &ButtonIm4
};

struct Image ButtonInvIm1=
{
  0,0,
  149,1,
  0,0,
  0,1,
  0
};

struct Image ButtonInvIm2=
{
  0,1,
  1,13,
  0,0,
  0,1,
  &ButtonInvIm1
};

struct Image ButtonInvIm3=
{
  1,13,
  149,1,
  0,0,
  0,2,
  &ButtonInvIm2
};

struct Image ButtonInvIm=
{
  149,1,
  1,13,
  0,0,
  0,2,
  &ButtonInvIm3
};

struct Image Pic2ValIm1=
{
  -101,27,
  149,1,
  0,0,
  0,1,
  0
};

struct Image Pic2ValIm2=
{
  47,15,
  1,13,
  0,0,
  0,1,
  &Pic2ValIm1
};

struct Image Pic2ValIm3=
{
  -102,14,
  1,13,
  0,0,
  0,2,
  &Pic2ValIm2
};

struct Image Pic2ValIm4=
{
  -102,14,
  149,1,
  0,0,
  0,2,
  &Pic2ValIm3
};

struct Image Pic2ValIm5=
{
  -1,-2,
  48,12,
  0,0,
  0,0,
  &Pic2ValIm4
};

struct Image Pic2ValIm6=
{
  -1,10,
  49,1,
  0,0,
  0,1,
  &Pic2ValIm5
};

struct Image Pic2ValIm7=
{
  47,-2,
  1,13,
  0,0,
  0,1,
  &Pic2ValIm6
};

struct Image Pic2ValIm8=
{
  -2,-3,
  1,13,
  0,0,
  0,2,
  &Pic2ValIm7
};

struct Image Pic2ValIm=
{
  -2,-3,
  49,1,
  0,0,
  0,2,
  &Pic2ValIm8
};

struct Image MiniBoxIm1=
{
  -1,-2,
  37,12,
  0,0,
  0,0,
  0
};

struct Image MiniBoxIm2=
{
  -1,10,
  38,1,
  0,0,
  0,1,
  &MiniBoxIm1
};

struct Image MiniBoxIm3=
{
  36,-2,
  1,13,
  0,0,
  0,1,
  &MiniBoxIm2
};

struct Image MiniBoxIm4=
{
  -2,-3,
  1,13,
  0,0,
  0,2,
  &MiniBoxIm3
};

struct Image MiniBoxIm=
{
  -2,-3,
  38,1,
  0,0,
  0,2,
  &MiniBoxIm4
};

struct Image Borders1=
{
  0,119,
  154,1,
  0,0,
  0,2,
  0
};

struct Image Borders2=
{
  153,0,
  1,120,
  0,0,
  0,2,
  &Borders1
};

struct Image Borders3=
{
  0,119,
  1,2,
  0,0,
  0,2,
  &Borders2
};

struct Image Borders4=
{
  1,121,
  470,1,
  0,0,
  0,1,
  &Borders3
};

struct Image Borders5=
{
  471,122,
  1,17,
  0,0,
  0,2,
  &Borders4
};

struct Image Borders6=
{
  315,119,
  157,1,
  0,0,
  0,2,
  &Borders5
};

struct Image Borders7=
{
  314,1,
  1,118,
  0,0,
  0,1,
  &Borders6
};

struct Image Borders8=
{
  312,0,
  2,1,
  0,0,
  0,2,
  &Borders7
};

struct Image Borders9=
{
  312,0,
  1,120,
  0,0,
  0,2,
  &Borders8
};

struct Image Borders10=
{
  156,119,
  157,1,
  0,0,
  0,2,
  &Borders9
};

struct Image Borders11=
{
  155,1,
  1,118,
  0,0,
  0,1,
  &Borders10
};

struct Image Borders12=
{
  153,0,
  2,1,
  0,0,
  0,2,
  &Borders11
};

struct Image Borders13=
{
  471,0,
  2,1,
  0,0,
  0,2,
  &Borders12
};

struct Image Borders14=
{
  471,0,
  1,120,
  0,0,
  0,2,
  &Borders13
};

struct Image Borders15=
{
  473,1,
  1,139,
  0,0,
  0,1,
  &Borders14
};

struct Image Borders=
{
  472,139,
  2,1,
  0,0,
  0,1,
  &Borders15
};

struct Image InfoImage=
{
  0,0,
  128,128,
  8,0,
  255,0,
  0
};

struct Image ProImage1=
{
  1,26,
  401,1,
  0,0,0,
  1,
  0
};

struct Image ProImage2=
{
  401,1,
  1,26,
  0,0,0,
  1,
  &ProImage1
};

struct Image ProImage3=
{
  0,0,
  1,26,
  0,0,0,
  2,
  &ProImage2
};

struct Image ProImage4=
{
  0,0,
  401,1,
  0,0,0,
  2,
  &ProImage3
};

struct Image ProImage=
{
  1,1,
  0,25,
  0,0,0,
  3,
  &ProImage4
};

/*----------------------------------------------------------------------------*/

struct IntuiText ChangeColorButtonT=
{
  1,0,
  JAM1,
  Change_Color_Offset,3,
  0,
  (UBYTE *)Change_Color,
  0
};

struct IntuiText PointsButtonT=
{
  1,0,
  JAM1,
  23,3,
  0,
  (UBYTE *)Points_On_Off,
  0
};

struct IntuiText ResetSplinesButtonT=
{
  1,0,
  JAM1,
  Reset_Splines_Offset,3,
  0,
  (UBYTE *)Reset_Splines,
  0
};

struct IntuiText DeleteAllButtonT=
{
  1,0,
  JAM1,
  Delete_All_Offset,3,
  0,
  (UBYTE *)Delete_All,
  0
};

struct IntuiText PointsBT=
{
  1,0,
  JAM1,
  -112,0,
  0,
  (UBYTE *)Selected_Point,
  0
};

struct IntuiText DPicYT=
{
  1,0,
  JAM1,
  -9,0,
  0,
  (UBYTE *)Times,
  0
};

struct IntuiText DPicXT=
{
  1,0,
  JAM1,
  -63,0,
  0,
  (UBYTE *)Dest_Pic,
  0
};

struct IntuiText QuitButtonT=
{
  1,0,
  JAM1,
  Quit_Offset,3,
  0,
  (UBYTE *)Quit,
  0
};

struct IntuiText ZoomButtonT=
{
  1,0,
  JAM1,
  23,3,
  0,
  (UBYTE *)Zoom_On_Off,
  0
};

struct IntuiText InfoButtonT=
{
  1,0,
  JAM1,
  AGA_Morph_V1_0_Info_Offset,3,
  0,
  (UBYTE *)AGA_Morph_V1_0_Info,
  0
};

struct IntuiText ShowRButtonT=
{
  1,0,
  JAM1,
  Show_rendered_Picture_Offset,3,
  0,
  (UBYTE *)Show_rendered_Picture,
  0
};

struct IntuiText Show2ButtonT=
{
  1,0,
  JAM1,
  Show_Picture_2_Offset,3,
  0,
  (UBYTE *)Show_Picture_2,
  0
};

struct IntuiText Show1ButtonT=
{
  1,0,
  JAM1,
  Show_Picture_1_Offset,3,
  0,
  (UBYTE *)Show_Picture_1,
  0
};

struct IntuiText RenderButtonT=
{
  1,0,
  JAM1,
  Render_Picture_Offset,3,
  0,
  (UBYTE *)Render_Picture,
  0
};

struct IntuiText SpLineButtonT=
{
  1,0,
  JAM1,
  23,3,
  0,
  (UBYTE *)Spline_On_Off,
  0
};

struct IntuiText Poi2SliderT=
{
  1,0,
  JAM1,
  1,-16,
  0,
  (UBYTE *)of_2nd_Poi,
  0
};

struct IntuiText Pic2SliderT=
{
  1,0,
  JAM1,
  1,-16,
  0,
  (UBYTE *)of_2nd_Pic,
  0
};

struct IntuiText DelPButtonT=
{
  1,0,
  JAM1,
  Delete_Point_Offset,3,
  0,
  (UBYTE *)Delete_Point,
  0
};

struct IntuiText AddPButtonT=
{
  1,0,
  JAM1,
  Add_Point_Offset,3,
  0,
  (UBYTE *)Add_Point,
  0
};

struct IntuiText ChangeSpButtonT=
{
  1,0,
  JAM1,
  Change_Spline_Offset,3,
  0,
  (UBYTE *)Change_Spline,
  0
};

struct IntuiText Change2ButtonT=
{
  1,0,
  JAM1,
  Change_Points_2_Offset,3,
  0,
  (UBYTE *)Change_Points_2,
  0
};

struct IntuiText Change1ButtonT=
{
  1,0,
  JAM1,
  Change_Points_1_Offset,3,
  0,
  (UBYTE *)Change_Points_1,
  0
};

struct IntuiText SavePButtonT=
{
  1,0,
  JAM1,
  Save_Points_Offset,3,
  0,
  (UBYTE *)Save_Points,
  0
};

struct IntuiText SavePicButtonT=
{
  1,0,
  JAM1,
  Save_Picture_Offset,3,
  0,
  (UBYTE *)Save_Picture,
  0
};

struct IntuiText LoadPButtonT=
{
  1,0,
  JAM1,
  Load_Points_Offset,3,
  0,
  (UBYTE *)Load_Points,
  0
};

struct IntuiText Load2ButtonT=
{
  1,0,
  JAM1,
  Load_Picture_2_Offset,3,
  0,
  (UBYTE *)Load_Picture_2,
  0
};

struct IntuiText Load1ButtonT=
{
  1,0,
  JAM1,
  Load_Picture_1_Offset,3,
  0,
  (UBYTE *)Load_Picture_1,
  0
};

struct IntuiText BorderText1=
{
  1,0,
  JAM1,
  480,3,
  0,
  (UBYTE *)Viewtext,
  0
};

struct IntuiText BorderText2=
{
  1,0,
  JAM1,
  321,3,
  0,
  (UBYTE *)Rendercontrol,
  &BorderText1
};

struct IntuiText BorderText3=
{
  1,0,
  JAM1,
  162,3,
  0,
  (UBYTE *)Pointcontrol,
  &BorderText2
};

struct IntuiText BorderText=
{
  1,0,
  JAM1,
  3,3,
  0,
  (UBYTE *)Project,
  &BorderText3
};

struct IntuiText ErrorCloseButtonT=
{
  1,0,
  JAM1,
  Oops_Offset,3,
  0,
  (UBYTE *)Oops,
  0
};

struct IntuiText AddressText6=
{
  3,0,
  JAM1,
  0,191,
  &NormalFont,
  (UBYTE *)Address6,
  0
};

struct IntuiText AddressText5=
{
  3,0,
  JAM1,
  0,182,
  &NormalFont,
  (UBYTE *)Address5,
  &AddressText6
};

struct IntuiText AddressText4=
{
  3,0,
  JAM1,
  0,164,
  &NormalFont,
  (UBYTE *)Address4,
  &AddressText5
};

struct IntuiText AddressText3=
{
  3,0,
  JAM1,
  0,155,
  &NormalFont,
  (UBYTE *)Address3,
  &AddressText4
};

struct IntuiText AddressText2=
{
  3,0,
  JAM1,
  0,146,
  &NormalFont,
  (UBYTE *)Address2,
  &AddressText3
};

struct IntuiText AddressText1=
{
  3,0,
  JAM1,
  0,137,
  &NormalFont,
  (UBYTE *)Address1,
  &AddressText2
};

struct IntuiText InfoText20=
{
  1,0,
  JAM1,
  132,191,
  &NormalFont,
  (UBYTE *)Info20,
  &AddressText1
};

struct IntuiText InfoText19=
{
  1,0,
  JAM1,
  132,182,
  &NormalFont,
  (UBYTE *)Info19,
  &InfoText20
};

struct IntuiText InfoText18=
{
  1,0,
  JAM1,
  132,173,
  &NormalFont,
  (UBYTE *)Info18,
  &InfoText19
};

struct IntuiText InfoText17=
{
  1,0,
  JAM1,
  132,164,
  &NormalFont,
  (UBYTE *)Info17,
  &InfoText18
};

struct IntuiText InfoText16=
{
  1,0,
  JAM1,
  132,155,
  &NormalFont,
  (UBYTE *)Info16,
  &InfoText17
};

struct IntuiText InfoText15=
{
  1,0,
  JAM1,
  132,146,
  &NormalFont,
  (UBYTE *)Info15,
  &InfoText16
};

struct IntuiText InfoText14=
{
  1,0,
  JAM1,
  132,137,
  &NormalFont,
  (UBYTE *)Info14,
  &InfoText15
};

struct IntuiText InfoText13=
{
  1,0,
  JAM1,
  132,128,
  &NormalFont,
  (UBYTE *)Info13,
  &InfoText14
};

struct IntuiText InfoText12=
{
  1,0,
  JAM1,
  132,119,
  &NormalFont,
  (UBYTE *)Info12,
  &InfoText13
};

struct IntuiText InfoText11=
{
  1,0,
  JAM1,
  132,110,
  &NormalFont,
  (UBYTE *)Info11,
  &InfoText12
};

struct IntuiText InfoText10=
{
  1,0,
  JAM1,
  132,101,
  &NormalFont,
  (UBYTE *)Info10,
  &InfoText11
};

struct IntuiText InfoText09=
{
  1,0,
  JAM1,
  132,92,
  &NormalFont,
  (UBYTE *)Info09,
  &InfoText10
};

struct IntuiText InfoText08=
{
  1,0,
  JAM1,
  132,83,
  &NormalFont,
  (UBYTE *)Info08,
  &InfoText09
};

struct IntuiText InfoText07=
{
  1,0,
  JAM1,
  132,74,
  &NormalFont,
  (UBYTE *)Info07,
  &InfoText08
};

struct IntuiText InfoText06=
{
  1,0,
  JAM1,
  132,65,
  &NormalFont,
  (UBYTE *)Info06,
  &InfoText07
};

struct IntuiText InfoText05=
{
  1,0,
  JAM1,
  132,56,
  &NormalFont,
  (UBYTE *)Info05,
  &InfoText06
};

struct IntuiText InfoText04=
{
  1,0,
  JAM1,
  132,47,
  &NormalFont,
  (UBYTE *)Info04,
  &InfoText05
};

struct IntuiText InfoText03=
{
  1,0,
  JAM1,
  132,38,
  &NormalFont,
  (UBYTE *)Info03,
  &InfoText04
};

struct IntuiText InfoText02=
{
  1,0,
  JAM1,
  132,29,
  &NormalFont,
  (UBYTE *)Info02,
  &InfoText03
};

struct IntuiText InfoText01=
{
  1,0,
  JAM1,
  132,20,
  &NormalFont,
  (UBYTE *)Info01,
  &InfoText02
};

struct IntuiText InfoText=
{
  1,0,
  JAM1,
  132,0,
  &NormalFont,
  (UBYTE *)InfoHeader,
  &InfoText01
};

struct IntuiText InfoCloseButtonT=
{
 1,0,
 JAM1,
 Ok_Offset,3,
 0,
 (UBYTE *)Ok,
 0
};

struct IntuiText LoadPicError=
{
  1,0,
  JAM1,
  Can_t_load_Picture_Offset-41,20-70,
  0,
  (UBYTE *)Can_t_load_Picture,
  0
};

struct IntuiText MemoryError=
{
  1,0,
  JAM1,
  Out_of_Memory_Offset-41,20-70,
  0,
  (UBYTE *)Out_of_Memory,
  0
};

struct IntuiText FileError=
{
  1,0,
  JAM1,
  Can_t_read_write_File_Offset-41,20-70,
  0,
  (UBYTE *)Can_t_read_write_File,
  0
};

struct IntuiText InfoError=
{
  1,0,
  JAM1,
  Can_t_open_Info_Window_Offset-41,20-70,
  0,
  (UBYTE *)Can_t_open_Info_Window,
  0
};

struct IntuiText WindowError=
{
  1,0,
  JAM1,
  Can_t_open_Window_Offset-41,20-70,
  0,
  (UBYTE *)Can_t_open_Window,
  0
};

struct IntuiText NoPicError=
{
  1,0,
  JAM1,
  Picture_missing_Offset-41,20-70,
  0,
  (UBYTE *)Picture_missing,
  0
};

/*----------------------------------------------------------------------------*/

struct PropInfo ViewWindowBar2p=
{
  AUTOKNOB | FREEVERT | PROPBORDERLESS | PROPNEWLOOK,
  0,0,
  MAXBODY,MAXBODY,
  0,0,0,0,0
};

struct PropInfo ViewWindowBar1p=
{
  AUTOKNOB | FREEHORIZ | PROPBORDERLESS | PROPNEWLOOK,
  0,0,
  MAXBODY,MAXBODY,
  0,0,0,0,0
};

struct PropInfo EditWindowBar2p=
{
  AUTOKNOB | FREEVERT | PROPBORDERLESS | PROPNEWLOOK,
  0,0,
  MAXBODY,MAXBODY,
  0,0,0,0,0
};

struct PropInfo EditWindowBar1p=
{
  AUTOKNOB | FREEHORIZ | PROPBORDERLESS | PROPNEWLOOK,
  0,0,
  MAXBODY,MAXBODY,
  0,0,0,0,0
};

struct PropInfo Poi2Sliderp=
{
  FREEHORIZ | PROPNEWLOOK | PROPBORDERLESS,
  0,0,
  649,MAXBODY,
  0,0,0,0,0
};

struct PropInfo Pic2Sliderp=
{
  FREEHORIZ | PROPNEWLOOK | PROPBORDERLESS,
  0,0,
  649,MAXBODY,
  0,0,0,0,0
};

/*----------------------------------------------------------------------------*/

struct StringInfo PointsBp=
{
  &PointsBBuf[0],
  &PointsBBuf[10],
  0,5,0,
  0,2,0,0,0,
  0,
  0,
  0
};

struct StringInfo DPicYp=
{
  &DPicYBuf[0],
  &DPicYBuf[10],
  0,5,0,
  0,4,0,0,0,
  0,
  256,
  0
};

struct StringInfo DPicXp=
{
  &DPicXBuf[0],
  &DPicXBuf[10],
  0,5,0,
  0,4,0,0,0,
  0,
  320,
  0
};

struct StringInfo Poi2Valp=
{
  &Poi2ValBuf[0],
  &Poi2ValBuf[8],
  0,4,0,
  0,2,0,0,0,
  0,
  0,
  0
};

struct StringInfo Pic2Valp=
{
  &Pic2ValBuf[0],
  &Pic2ValBuf[8],
  0,4,0,
  0,2,0,0,0,
  0,
  0,
  0
};

/*----------------------------------------------------------------------------*/

struct Gadget ViewWindowBar2=
{
  0,
  -13,12,
  10,-23,
  GFLG_GADGIMAGE | GFLG_RELRIGHT | GFLG_RELHEIGHT,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_RIGHTBORDER,
  GTYP_PROPGADGET | GTYP_GZZGADGET,
  &ViewWindowBar2r,
  0,
  0,
  0,
  &ViewWindowBar2p,
  2,
  0
};

struct Gadget ViewWindowBar1=
{
  &ViewWindowBar2,
  3,-7,
  -23,6,
  GFLG_GADGIMAGE | GFLG_RELBOTTOM | GFLG_RELWIDTH,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_BOTTOMBORDER,
  GTYP_PROPGADGET | GTYP_GZZGADGET,
  &ViewWindowBar1r,
  0,
  0,
  0,
  &ViewWindowBar1p,
  1,
  0
};

struct Gadget EditWindowBar2=
{
  0,
  -13,12,
  10,-23,
  GFLG_GADGIMAGE | GFLG_RELRIGHT | GFLG_RELHEIGHT,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_RIGHTBORDER,
  GTYP_PROPGADGET | GTYP_GZZGADGET,
  &EditWindowBar2r,
  0,
  0,
  0,
  &EditWindowBar2p,
  2,
  0
};

struct Gadget EditWindowBar1=
{
  &EditWindowBar2,
  3,-7,
  -23,6,
  GFLG_GADGIMAGE | GFLG_RELBOTTOM | GFLG_RELWIDTH,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_BOTTOMBORDER,
  GTYP_PROPGADGET | GTYP_GZZGADGET,
  &EditWindowBar1r,
  0,
  0,
  0,
  &EditWindowBar1p,
  1,
  0
};

struct Gadget ChangeColorButton=
{
  0,
  320,129,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &ChangeColorButtonT,
  0,
  0,
  29,
  0
};

struct Gadget PointsButton=
{
  &ChangeColorButton,
  479,105,
  20,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_TOGGLESELECT,
  GTYP_BOOLGADGET,
  &RadioOffIm,
  &RadioOnIm,
  &PointsButtonT,
  0,
  0,
  28,
  0
};

struct Gadget ResetSplinesButton=
{
  &PointsButton,
  161,105,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &ResetSplinesButtonT,
  0,
  0,
  27,
  0
};

struct Gadget DeleteAllButton=
{
  &ResetSplinesButton,
  2,105,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &DeleteAllButtonT,
  0,
  0,
  26,
  0
};

struct Gadget PointsB=
{
  &DeleteAllButton,
  274,132,
  35,8,
  GFLG_GADGIMAGE | GFLG_GADGHNONE,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_LONGINT,
  GTYP_STRGADGET,
  &MiniBoxIm,
  0,
  &PointsBT,
  0,
  &PointsBp,
  25,
  0
};

struct Gadget DPicY=
{
  &PointsB,
  114,132,
  35,8,
  GFLG_GADGIMAGE | GFLG_GADGHNONE,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_LONGINT,
  GTYP_STRGADGET,
  &MiniBoxIm,
  0,
  &DPicYT,
  0,
  &DPicYp,
  24,
  0
};

struct Gadget DPicX=
{
  &DPicY,
  66,132,
  35,8,
  GFLG_GADGIMAGE | GFLG_GADGHNONE,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_LONGINT,
  GTYP_STRGADGET,
  &MiniBoxIm,
  0,
  &DPicXT,
  0,
  &DPicXp,
  23,
  0
};

struct Gadget QuitButton=
{
  &DPicX,
  479,122,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &QuitButtonT,
  0,
  0,
  22,
  0
};

struct Gadget ZoomButton=
{
  &QuitButton,
  479,88,
  20,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_TOGGLESELECT,
  GTYP_BOOLGADGET,
  &RadioOffIm,
  &RadioOnIm,
  &ZoomButtonT,
  0,
  0,
  21,
  0
};

struct Gadget InfoButton=
{
  &ZoomButton,
  479,71,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &InfoButtonT,
  0,
  0,
  20,
  0
};

struct Gadget ShowRButton=
{
  &InfoButton,
  479,54,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &ShowRButtonT,
  0,
  0,
  19,
  0
};

struct Gadget Show2Button=
{
  &ShowRButton,
  479,37,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &Show2ButtonT,
  0,
  0,
  18,
  0
};

struct Gadget Show1Button=
{
  &Show2Button,
  479,20,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &Show1ButtonT,
  0,
  0,
  17,
  0
};

struct Gadget RenderButton=
{
  &Show1Button,
  320,105,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &RenderButtonT,
  0,
  0,
  16,
  0
};

struct Gadget SpLineButton=
{
  &RenderButton,
  320,88,
  20,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE | GFLG_SELECTED,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_TOGGLESELECT,
  GTYP_BOOLGADGET,
  &RadioOffIm,
  &RadioOnIm,
  &SpLineButtonT,
  0,
  0,
  15,
  0
};

struct Gadget Poi2Val=
{
  &SpLineButton,
  422,57,
  46,8,
  GFLG_GADGIMAGE | GFLG_GADGHNONE,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_LONGINT,
  GTYP_STRGADGET,
  &Pic2ValIm,
  0,
  0,
  0,
  &Poi2Valp,
  14,
  0
};

struct Gadget Poi2Slider=
{
  &Poi2Val,
  322,73,
  146,10,
  GFLG_GADGIMAGE | GFLG_GADGHNONE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_PROPGADGET,
  &Poi2Slider1r,
  0,
  &Poi2SliderT,
  0,
  &Poi2Sliderp,
  13,
  0
};

struct Gadget Pic2Val=
{
  &Poi2Slider,
  422,23,
  46,8,
  GFLG_GADGIMAGE | GFLG_GADGHNONE,
  GACT_RELVERIFY | GACT_IMMEDIATE | GACT_LONGINT,
  GTYP_STRGADGET,
  &Pic2ValIm,
  0,
  0,
  0,
  &Pic2Valp,
  12,
  0
};

struct Gadget Pic2Slider=
{
  &Pic2Val,
  322,39,
  146,10,
  GFLG_GADGIMAGE | GFLG_GADGHNONE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_PROPGADGET,
  &Pic2Slider1r,
  0,
  &Pic2SliderT,
  0,
  &Pic2Sliderp,
  11,
  0
};

struct Gadget DelPButton=
{
  &Pic2Slider,
  161,88,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &DelPButtonT,
  0,
  0,
  10,
  0
};

struct Gadget AddPButton=
{
  &DelPButton,
  161,71,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &AddPButtonT,
  0,
  0,
  9,
  0
};

struct Gadget ChangeSpButton=
{
  &AddPButton,
  161,54,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &ChangeSpButtonT,
  0,
  0,
  8,
  0
};

struct Gadget Change2Button=
{
  &ChangeSpButton,
  161,37,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &Change2ButtonT,
  0,
  0,
  7,
  0
};

struct Gadget Change1Button=
{
  &Change2Button,
  161,20,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &Change1ButtonT,
  0,
  0,
  6,
  0
};

struct Gadget SavePButton=
{
  &Change1Button,
  2,88,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &SavePButtonT,
  0,
  0,
  5,
  0
};

struct Gadget SavePicButton=
{
  &SavePButton,
  2,71,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &SavePicButtonT,
  0,
  0,
  4,
  0
};

struct Gadget LoadPButton=
{
  &SavePicButton,
  2,54,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &LoadPButtonT,
  0,
  0,
  3,
  0
};

struct Gadget Load2Button=
{
  &LoadPButton,
  2,37,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &Load2ButtonT,
  0,
  0,
  2,
  0
};

struct Gadget Load1Button=
{
  &Load2Button,
  2,20,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &Load1ButtonT,
  0,
  0,
  1,
  0
};

struct Gadget BorderGadget=
{
  &Load1Button,
  2,3,
  0,0,
  GFLG_GADGIMAGE | GFLG_GADGHNONE,
  0,
  GTYP_BOOLGADGET,
  &Borders,
  0,
  &BorderText,
  0,
  0,
  0,
  0
};

struct Gadget ErrorCloseButton=
{
  0,
  41,70,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &ErrorCloseButtonT,
  0,
  0,
  1,
  0
};

struct Gadget InfoCloseButton=
{
  0,
  88,205,
  150,14,
  GFLG_GADGIMAGE | GFLG_GADGHIMAGE,
  GACT_RELVERIFY | GACT_IMMEDIATE,
  GTYP_BOOLGADGET,
  &ButtonIm,
  &ButtonInvIm,
  &InfoCloseButtonT,
  0,
  0,
  1,
  0
};

/*----------------------------------------------------------------------------*/

UWORD SliderInfo[]={0x0000,0x0000,0x0000,
                    0x0000,0x0000,0x0004,
                    0x0000,0x0000,0x0004,
                    0x0000,0x0000,0x0004,
                    0x0000,0x0000,0x0004,
                    0x0000,0x0000,0x0004,
                    0x0000,0x0000,0x0004,
                    0x0000,0x0000,0x0004,
                    0x0000,0x0000,0x0004,
                    0x7fff,0xffff,0xfffc,

                    0xffff,0xffff,0xfff8,
                    0x8000,0x0000,0x0000,
                    0x8000,0x0000,0x0000,
                    0x8000,0x0000,0x0000,
                    0x8000,0x0000,0x0000,
                    0x8000,0x0000,0x0000,
                    0x8000,0x0000,0x0000,
                    0x8000,0x0000,0x0000,
                    0x8000,0x0000,0x0000,
                    0x0000,0x0000,0x0000};

UWORD RadioInfo[]={0x0000,0x4000,
                   0x0000,0x6000,
                   0x0000,0x3000,
                   0x0000,0x3000,
                   0x0000,0x3000,
                   0x0000,0x3000,
                   0x0000,0x3000,
                   0x0000,0x3000,
                   0x0000,0x3000,
                   0x0000,0x3000,
                   0x0000,0x3000,
                   0x0000,0x3000,
                   0x0000,0x6000,
                   0x1fff,0xc000,

                   0x3fff,0x8000,
                   0x6000,0x0000,
                   0xc000,0x0000,
                   0xc000,0x0000,
                   0xc000,0x0000,
                   0xc000,0x0000,
                   0xc000,0x0000,
                   0xc000,0x0000,
                   0xc000,0x0000,
                   0xc000,0x0000,
                   0xc000,0x0000,
                   0xc000,0x0000,
                   0x6000,0x0000,
                   0x2000,0x0000,

                   0x3fff,0x8000,
                   0x6000,0x0000,
                   0xc000,0x0000,
                   0xc7fe,0x0000,
                   0xcfff,0x0000,
                   0xcfff,0x0000,
                   0xcfff,0x0000,
                   0xcfff,0x0000,
                   0xcfff,0x0000,
                   0xcfff,0x0000,
                   0xc7fe,0x0000,
                   0xc000,0x0000,
                   0x6000,0x0000,
                   0x2000,0x0000,

                   0x0000,0x4000,
                   0x0000,0x6000,
                   0x0000,0x3000,
                   0x07fe,0x3000,
                   0x0fff,0x3000,
                   0x0fff,0x3000,
                   0x0fff,0x3000,
                   0x0fff,0x3000,
                   0x0fff,0x3000,
                   0x0fff,0x3000,
                   0x07fe,0x3000,
                   0x0000,0x3000,
                   0x0000,0x6000,
                   0x1fff,0xc000};

UWORD InfoInfo[]={0xFFFF,0xFFFF,0xFFFF,0xF5FF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
                  0xAB7F,0xFFFF,0xFFFF,0xED7F,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
                  0xFFF7,0x7BFF,0xFFFF,0xC3DF,0xFFFF,0xDFFF,0xFFFF,0xFFFF,
                  0xB6DF,0xFFFF,0xFFFE,0x297F,0xFEFF,0xFFFF,0xFFFF,0xFFFB,
                  0xFFFD,0xB7BF,0xFFFC,0x81DF,0xEE3F,0x7FFF,0xFFFF,0xDF7F,
                  0xBB7F,0xFEFF,0xDFF8,0xC555,0xFC1F,0xFFEF,0xFFFF,0xFFFF,
                  0xEFDB,0x6FFB,0x7FF2,0x82BF,0xF9BF,0xFFFF,0xFFFF,0xFFFF,
                  0x7AFF,0xFFFF,0xFAE0,0x0BEF,0xF1CF,0xFFFF,0xFFFF,0xFFFF,
                  0xDFBD,0xBBFF,0xFF80,0x12FF,0xF037,0xFDFF,0xF7FF,0xFFFF,
                  0xB5EF,0x777F,0xFD00,0x17FF,0xFC0B,0xDF7E,0xFFFB,0xFFFE,
                  0x7EFB,0xDFFD,0xFE10,0x2EFF,0xF505,0xFBFB,0xFFFF,0xFFFF,
                  0xD7BE,0xFFFF,0xFE7F,0x3FFF,0xFE17,0xFFFF,0xFFFD,0xFFFF,
                  0xFBEF,0xF6FF,0xF47E,0xF7FB,0xFE87,0xDBDF,0xFFDF,0xFFFF,
                  0x5EBB,0x7FDE,0xF8E8,0x0BDF,0xDE83,0xEEFF,0xF6FF,0xFFFF,
                  0xEBFF,0xEFFF,0xF9A0,0x57FD,0x7747,0xBDBF,0xFFFF,0xFFFF,
                  0x7756,0xFDFB,0xF356,0xBF77,0xDFEB,0xF7EF,0x7FFF,0xFFFF,
                  0xBDFF,0xFFBF,0x8C50,0x5FDE,0xF5A7,0xDEF7,0xFFFF,0xFFFD,
                  0xD7BB,0xBEFF,0xCA75,0xEF77,0x5F3F,0xF7AF,0xFFFF,0xFFFF,
                  0xBDEE,0xF7FF,0x51EF,0xBEDD,0xEBB8,0xFFF7,0xFFFF,0xFFFF,
                  0xD77B,0xDFFB,0xA4DB,0x7DF7,0xBDFF,0x7ABB,0xFFFF,0xFFFF,
                  0x7DEF,0xFDFF,0x99DB,0x6F5D,0x6B7F,0xBFDF,0xEDFF,0xFFFF,
                  0xD77E,0xFFBF,0xABA7,0x75B7,0xDDFF,0xDF6A,0xFFF7,0xBFFF,
                  0xBDDF,0xFFFB,0xD31E,0xDFD5,0x775B,0xFFFF,0xFEDE,0xFFFF,
                  0xEF7B,0xBFFE,0xD2F7,0xEA77,0xBBEF,0xFEBA,0xDBFF,0xFFFF,
                  0xBAFF,0xF7BD,0xD3FF,0x5FDD,0xD6B6,0xBFDB,0x7FBD,0xDEFF,
                  0xF7DB,0x7FFD,0xD3FD,0xFAB6,0xBB7B,0xCF7D,0xEDF7,0xFBFF,
                  0x5FFF,0xFFFB,0xEFFB,0xEEDB,0xADAF,0xEBAE,0xFEFD,0x5FFF,
                  0xF6B7,0xDBFF,0x96D6,0xFD6D,0x76FF,0xEFF7,0x77AF,0xFF6F,
                  0xBFFF,0x7FF7,0xFFE2,0xDBB6,0xF5BE,0xF7BD,0x7AF6,0xEBFF,
                  0xEDFF,0xFFFE,0xB5EA,0x3FED,0x9ED0,0xEFEE,0xFBBD,0xBF77,
                  0xBFBF,0xFFDD,0xAD51,0x1FFB,0x6B54,0xFD7B,0xBD6F,0xEDFF,
                  0xFDF7,0xFFF7,0xF5E7,0x37DD,0xDDBF,0x2FDE,0xDBD5,0x77BF,
                  0xB7FF,0xFFFB,0xDBCD,0xC57F,0x6DEB,0xC7FF,0x5ABD,0xADED,
                  0xFFFF,0xFDDA,0xE587,0xC07D,0xBF7E,0x2BBA,0xE5D6,0xDEFB,
                  0xFFBF,0xF677,0x562B,0xF45B,0xEEE0,0x0FFF,0x2EBB,0x735F,
                  0xFFFF,0xFFEA,0xB865,0xA8AE,0xFC00,0x2BFE,0xED55,0x5F77,
                  0xDFFF,0x55ED,0xEC6E,0xFD25,0x016A,0x37F7,0xAED6,0xD5DD,
                  0xFFFF,0xFDD5,0x54F4,0xFF46,0xA768,0x5FFD,0x54AB,0x6AB7,
                  0xFFFA,0xABAB,0xD17C,0xFEFF,0xE5FA,0x5FFF,0xD6AA,0xB77F,
                  0xFFD7,0x68AA,0x32F9,0xBFDF,0xFFFC,0x37FD,0x5555,0x59AA,
                  0xFB7A,0xD4D5,0x63FD,0xEFFF,0x7DFE,0x1FFE,0xAA95,0x55B7,
                  0xFED6,0xA8AB,0xEBFE,0xFFFD,0xBFEE,0x15EA,0xAEAA,0xAADA,
                  0xEBB5,0x555B,0xDFED,0x7FD6,0xBFFF,0x0B7E,0xA449,0x556D,
                  0xBD5A,0xA2AB,0x4FFE,0xFD69,0x4FF7,0x8BFA,0xB524,0xAAB7,
                  0xEFA9,0x2B6B,0x8FDF,0x7B54,0x37EF,0x4AFE,0x944A,0x5559,
                  0xB4D4,0x8357,0xBDF7,0xFD49,0x4FFF,0xC55B,0x6B25,0x1557,
                  0xEB6A,0x2AAD,0xDF7B,0xF524,0x2BFB,0xD37E,0xA444,0xA956,
                  0xAC91,0x02F7,0x7FAF,0xFA91,0x5FFF,0xD07B,0x5511,0x0AAB,
                  0xB528,0x015F,0x5EF5,0xE448,0x25FF,0xC07D,0x5B04,0xA555,
                  0xCA84,0x40AE,0x3F55,0x7112,0x97BF,0xF077,0x2992,0x10AA,
                  0x5410,0x055D,0x7DD5,0x9449,0x537E,0x817D,0xAA80,0x4A55,
                  0xA000,0x04D7,0x7FB5,0x6924,0x95FF,0x417A,0x8889,0x152B,
                  0x4C40,0x4B7F,0xBF55,0xA492,0x55FF,0x203E,0xAB00,0x4294,
                  0x9100,0x0ACF,0xBFD4,0xAA4A,0xA9FF,0x809B,0x5411,0x144A,
                  0x2001,0x4977,0x2EAA,0xA129,0x55FF,0x405D,0x2904,0x0125,
                  0x0005,0x2CAF,0xBFEA,0xAA25,0x227F,0xA01E,0xAA00,0x2085,
                  0x0010,0xBD2B,0xAFB5,0x0854,0xAAAE,0x805D,0x2900,0x0828,
                  0x0046,0xAE37,0xBFAA,0xA105,0x485F,0xE89E,0xAB80,0x2105,
                  0x0112,0xAE1B,0xBED4,0x8824,0x936F,0xA03B,0x5100,0x0052,
                  0x024A,0xFEEA,0xBFA9,0x2242,0x8837,0xD83D,0x2C00,0x0409,
                  0x092B,0x5F37,0xBEA4,0x0015,0x555F,0xEA7A,0xB000,0x0024,
                  0x2555,0xB2B5,0x3F55,0x5508,0xA4AF,0xD41F,0x4A00,0x0042,
                  0x4AAE,0xF8FD,0x7AAA,0x20A5,0x2A57,0xFA3A,0x3608,0x0001,
                  0x2AB7,0xD06B,0x7FFF,0xD512,0xA95F,0xAABF,0x4A00,0x0008,
                  0xABDB,0x74FD,0xF69F,0x8DFD,0xD6BF,0x4BFB,0x2A54,0x8002,
                  0x556F,0xF4B7,0xFFFE,0x08BE,0xB5FE,0x3DEF,0x4A80,0x0000,
                  0xBFFF,0xFEF6,0xEFFD,0x46AF,0xEBE7,0xBFFD,0xA85A,0x5002,
                  0xAB6F,0xFBF6,0xF7FA,0x1B07,0xBF9C,0xDFFF,0xA920,0x8008,
                  0x77FF,0xFEAF,0xEBDE,0xB3C5,0x5675,0x2FFF,0xB50A,0x0000,
                  0xBFFF,0xFAC3,0xEBC4,0xEDE6,0xACE9,0x22BF,0x5AA0,0xAA00,
                  0xEFFF,0xEFAF,0xD1E5,0x6D26,0x15A0,0xBDEF,0xBB55,0x0080,
                  0xFFFE,0xB695,0xE46E,0x3FED,0x0DDE,0x46BF,0xF552,0x5400,
                  0xBFFB,0xFBB5,0xD115,0x25EA,0x4DFF,0x23F3,0xFEA9,0x2040,
                  0xFFEF,0x5EED,0xD0AA,0x4FC0,0x95CF,0xD3EA,0xB6A5,0x4A00,
                  0xFD75,0xD363,0xC449,0x57CA,0x0D8F,0xA1D5,0xFED5,0x4110,
                  0xDFAE,0xBDA1,0xA115,0x7D41,0x148B,0x53A1,0xF355,0x5A84,
                  0xF575,0xA5D1,0x9402,0xA594,0x4F9F,0xC605,0xF15A,0xA410,
                  0xD6AA,0xAA93,0xA010,0x0201,0x0C47,0x4481,0xEB6A,0xA940,
                  0xBAB5,0x55C1,0xAA05,0x5428,0x288D,0xE061,0xFED5,0x5292,
                  0xCAAD,0x54A3,0xC040,0x0005,0x4F47,0xBFED,0xF555,0xA820,
                  0x7552,0xAA69,0xB510,0x1150,0x2645,0xDFA3,0xF7F6,0x5584,
                  0xAAAA,0xA55D,0xD005,0x0002,0x9E63,0x7BC5,0xEEAA,0xAA50,
                  0x5449,0x2A21,0xED50,0x4055,0x2763,0xFE87,0xFFBA,0xD54A,
                  0x92A5,0x5293,0xEA0A,0x120A,0x5633,0xEA87,0xEDED,0x7AA0,
                  0x5528,0x0881,0x75A0,0x4055,0x1532,0xFE0D,0xFF77,0x4A9A,
                  0xA916,0xA655,0xF4AA,0x0014,0x4F33,0xDA17,0x7DB5,0xB564,
                  0x24A0,0x9025,0xBA91,0x0052,0x0339,0x740F,0x7FFB,0x5550,
                  0x9214,0x2281,0xFD4A,0x2251,0x94FB,0xDC3F,0xBDAE,0xDD4A,
                  0x4942,0x8826,0xF550,0x802A,0x8AA8,0xF22E,0xFFFB,0x6AA9,
                  0x0410,0x220B,0xFEAA,0x005C,0x7FFD,0x545F,0xFEDD,0xAD54,
                  0x5124,0x08A2,0xEDA4,0x2019,0xFDEC,0xE8BF,0xFDF6,0xB552,
                  0x0001,0x4000,0xFED1,0x001C,0xC26C,0xF07E,0xFFBF,0xD6AA,
                  0x1290,0x0023,0xFD6A,0x0000,0xCFB8,0xD0DE,0xFEF6,0xB5A9,
                  0x4004,0x1248,0x7F50,0x4040,0x33D0,0xE17F,0xFFDF,0x6D54,
                  0x0000,0x8000,0xFEAA,0x0102,0x2C49,0xA1FD,0xFBFB,0xBBAA,
                  0x0440,0x0900,0xFF54,0x8410,0xB606,0xD2FC,0xFFBD,0xED75,
                  0x4004,0x0021,0x3ED5,0x1044,0x0188,0xABBF,0xFFF7,0x77AA,
                  0x0000,0x8005,0x7F6A,0x4290,0xA3A0,0x8BF9,0xFFFD,0xDD55,
                  0x1000,0x0401,0x3FB5,0x2EA5,0x5B80,0x4EFF,0xFFB7,0x77EA,
                  0x0010,0x1001,0x5EDA,0xAA97,0xDD42,0x0FFF,0xFFFE,0xDD55,
                  0x0000,0x0001,0xBFDD,0xD3EF,0xE80F,0x1DBF,0xFFFB,0xF7B5,
                  0x1000,0x8001,0xDF77,0x7C50,0x01FD,0x1FF7,0x7FDF,0xBDD5,
                  0x0000,0x0009,0xCFFD,0xEDEF,0x83FB,0xB6FB,0xFFFE,0xF6DA,
                  0x0084,0x0001,0xD7D7,0x7DF8,0x15BC,0x3FFF,0xFFFB,0xDF6A,
                  0x2000,0x0001,0xEBFB,0xEAAC,0xFF18,0x377E,0xFFFF,0x75EA,
                  0x0200,0x0003,0xE7DD,0x757F,0x5E38,0x7FEB,0xDFFF,0xFF75,
                  0x0000,0x0008,0xF2F7,0xF5FD,0xFA74,0xBDF7,0xFFFF,0x6BAD,
                  0x0000,0x0117,0xFBFF,0xFD39,0xABD0,0xF7FF,0xFBFF,0xBEF4,
                  0x0000,0x0427,0xF17F,0xF6DE,0x7FE9,0xFDBF,0xBFFE,0xFBAE,
                  0x0000,0x205D,0xFCFF,0xFF7F,0xF412,0xEFAF,0xF7FF,0xEFD5,
                  0x0000,0x8B65,0xFE5F,0xF5AF,0xFC0B,0xBBC2,0xFFFD,0xFEEA,
                  0x0002,0x21D9,0xFE56,0xFEEA,0xFF15,0xFF51,0x5EFF,0x6DBD,
                  0x0008,0x01F3,0xFF8B,0xFF6A,0xAF07,0x6B7E,0xA7FF,0xFFA6,
                  0x0080,0x89D9,0xF78A,0xFDB6,0xDE95,0xFF5A,0xA9FF,0xDDFA,
                  0x0210,0x05FB,0xFDC1,0x7EDA,0xFE0B,0xB76D,0x847F,0xF6AB,
                  0x1040,0x01F9,0xF7C0,0xFF6B,0x7E2E,0xFF57,0x121F,0xFFBA,
                  0x0400,0x11ED,0xFFF0,0x2DBF,0xFD57,0xD7BF,0xC083,0xD5D6,
                  0x2000,0x01F9,0xFDF2,0x1FEF,0xFC7A,0xFB6F,0xE041,0xFEEA,
                  0x0010,0xA5AC,0xEF78,0x0FFF,0x14AF,0xAFAB,0xE014,0x3BBB,
                  0x0104,0x10EC,0xFBFC,0x8154,0x01F6,0xDBDF,0xF001,0x076C,
                  0x0441,0x21D6,0xFDFE,0x60A0,0x13AF,0xEF57,0xE21A,0x41D6,
                  0x0014,0x00F6,0xFF7F,0x1AA2,0x9EFA,0x5BBB,0xF885,0xA87A,
                  0x0040,0x41EE,0xFBDF,0x0DAF,0x7F57,0xDFD7,0xB822,0x550B,
                  0x0009,0x24F2,0x7EF7,0xC37F,0xFDFA,0xB76F,0xF111,0x5484,
                  0x4042,0x10EA,0xFF5F,0xE5FF,0xFFAD,0xDFBB,0xF24D,0xB6A1,
                  0x2010,0x80E9,0x3BF7,0xF8EF,0xFB6B,0x77D7,0xD116,0xDAB8,
                  0x4044,0x52A5,0x3EBD,0xF47F,0x77BD,0xBF7F,0xF015,0xBFA5,
                  0x1010,0x88B4,0x3FEF,0xFE0B,0xDD56,0xD7AF,0xE027,0xEDFA,

                  0xB6DE,0xFB7F,0xEFFF,0xF5FF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
                  0xDF77,0xBFEB,0x7DB7,0xE97B,0xFDB6,0xEDBF,0xFEFF,0xEFFF,
                  0x6ADB,0xEB7F,0xFFFF,0xD7DF,0x7FFF,0xBFF7,0xDFFB,0xBEDB,
                  0xBDFE,0xBDDD,0xB7FE,0xFD7F,0xFBFF,0xEFDE,0xFFFF,0xFBFE,
                  0xD755,0xEFB7,0xFDBD,0xF1DF,0xEF3A,0xFEFF,0xFB6F,0xDF7B,
                  0x7BFE,0xBAFB,0xAFFB,0xCD54,0xFEDF,0x7FF7,0xBFFD,0xFFFF,
                  0xB6AB,0xEFAE,0xFB5F,0xC2BF,0xF9BB,0xD77E,0xFFEF,0x7DEE,
                  0xDB7E,0xB5FB,0xBFF2,0x9BEB,0xD7CE,0xFBFB,0xFDBF,0xF7BB,
                  0x6DD5,0xDF5E,0xEBB5,0x56BD,0xB0F7,0xAFEF,0xD7FB,0xFFFF,
                  0xAABB,0x75F7,0xFD44,0x97EF,0x7D5B,0x7AFF,0xFFFF,0xBFF7,
                  0xBF6D,0xBF5D,0xBE90,0xAFF5,0xF525,0xDEFF,0xFFFE,0xFB7F,
                  0xA9DF,0x6BF7,0x7777,0x3B56,0xA656,0xB5B7,0xF7DB,0xFFFB,
                  0x6EB5,0xDEBF,0xFC56,0xF5BB,0xDA06,0xEBDF,0xBFFF,0xFFEF,
                  0xB5FE,0xB7D5,0x58E9,0x0AD5,0x6EB3,0xB6BE,0xFEFF,0xDEFF,
                  0xAB57,0xFAFF,0xF9A4,0x575A,0xAB47,0x5D7F,0xFFFF,0xFFFD,
                  0xB6DA,0xAF56,0xF316,0xB5AB,0x5AE3,0x65AF,0xFFFF,0xFFF7,
                  0xADB7,0xFDFF,0x8C51,0x5D6D,0x6B25,0xBAD7,0xFFFF,0xFF7F,
                  0x76DD,0x776D,0xDA75,0xEB55,0x55BF,0x576F,0xFFFF,0xFFFF,
                  0xAB6B,0xDBDF,0x51AE,0x9D55,0x6D5C,0xEAAB,0xFFFF,0xFFFF,
                  0xDDDD,0x7DFB,0xA4C9,0x656B,0x2AAF,0x755B,0xFFFF,0xFFFD,
                  0x6AB7,0xDF5F,0x989A,0x9AAC,0xD6EA,0xBDAD,0xCFFF,0xFFFF,
                  0xBFDD,0x75F7,0xAAA6,0x5553,0x2AB7,0x4AB5,0xFFB7,0xBFFF,
                  0x5577,0xFFBD,0x9315,0x55AC,0xD555,0xDDAA,0xB6CC,0xFFFF,
                  0xEEDD,0xAFEE,0xD2AA,0xD4A6,0xAAAA,0xF6AD,0xD97F,0xFFFF,
                  0x5B7F,0xFBBD,0x52AD,0x5AAA,0xAB5A,0xEB56,0x6FAF,0x56FF,
                  0xEDD5,0x7FFD,0xD355,0x66B5,0x556B,0x4D59,0x67BF,0xDB7F,
                  0x5F7F,0xEFFA,0xADEA,0xB295,0x5555,0xEAAA,0x9FFF,0xDDFF,
                  0xF5F7,0xBFFD,0x1796,0xDD55,0x6ABD,0x6ED5,0x2307,0xEF47,
                  0x5FBE,0xFFF2,0xEBA2,0x5555,0x554A,0xA354,0xF0D3,0xAF7D,
                  0xF5F7,0xFFF5,0x24A9,0x2AAA,0xAAA8,0xAD56,0xB92F,0x9F67,
                  0xBF7F,0xFFCC,0x9956,0x17DA,0xAAAC,0xD55A,0x97C6,0xB8BF,
                  0xEDFF,0xFFEA,0xE4C7,0xD54A,0xAAA5,0x6B55,0x6280,0x5336,
                  0xBFFF,0xFFAA,0x9A97,0xC17A,0xD55B,0x455A,0x87E8,0xFFCD,
                  0xFFFF,0xFFD2,0xA10B,0xC02B,0x5AAC,0x2B56,0x637C,0x77B1,
                  0xFFFF,0xE329,0x562D,0xD459,0x56C0,0x895A,0x9C11,0xD9CF,
                  0xFFFF,0xF7D5,0x2C27,0xF886,0xB400,0x4AEA,0xA7FF,0xCA52,
                  0xFFFD,0xF7A2,0xBC72,0xBB20,0x016E,0x3355,0x417C,0x0179,
                  0xFFF7,0x6990,0x90FA,0xFA07,0xA372,0x4D55,0x2D46,0x3FE5,
                  0xFEBF,0xFC4A,0xD0E8,0x7EFD,0xE5F8,0x56B6,0x91FC,0x6256,
                  0xF7FD,0x3D12,0x1179,0xFF57,0x7DFD,0x135A,0x46B8,0x337E,
                  0xDE30,0x7E49,0x21F8,0x6FFF,0xFDFA,0x0D6A,0x2BEA,0xE312,
                  0xEC7D,0xD624,0xB5BA,0xFFF8,0xFFFE,0x1CA9,0x5300,0x7070,
                  0x42EF,0xFE93,0x55EC,0x7FC3,0x5FFE,0x0F55,0x05B6,0xE238,
                  0x97F5,0x5D55,0x6FFD,0x5D3E,0xE6F7,0x02AA,0x54D1,0x501A,
                  0xBAFC,0x4609,0x1FDE,0x602B,0xDFED,0x48B4,0xA5B5,0x8B8C,
                  0xE22B,0x7EA6,0x9DF6,0xB8B6,0xBF7F,0x8175,0x25DE,0x6223,
                  0xBE3F,0xD491,0xDF7A,0xF25B,0xDBFB,0xC255,0x52BB,0x44FB,
                  0x076E,0xFD4C,0xF7AB,0xF16E,0x2FDF,0x402A,0x09EE,0xB55D,
                  0xDA97,0xF42F,0x3CFF,0xEBB7,0xD9F5,0x4052,0xADFA,0x580E,
                  0x757B,0xB8A4,0x2F5F,0x7AED,0x7FBB,0x502A,0x446D,0xEF47,
                  0xA3EF,0x5555,0x59F8,0xBBB6,0xAF7D,0x012A,0x92FF,0xB7A8,
                  0x1FFD,0xB02B,0xF7B0,0x56DB,0x63FC,0x8052,0x48B6,0xEA9D,
                  0xB3AE,0xD6C9,0xEF78,0xF37D,0x8FF6,0x0029,0x24FF,0xBD6F,
                  0x6EF5,0x6656,0xB7C2,0x75B1,0xC77E,0xA00A,0x91EA,0xEB25,
                  0xDF5A,0x90A5,0x9683,0xAAF6,0x88D5,0x4054,0x2B5B,0xFED8,
                  0xFDA4,0xA12B,0x9BFF,0x55D0,0x4DFA,0x804A,0x91F6,0x9F7A,
                  0xF6B5,0x404A,0xAF9F,0xB7A9,0x5124,0x0254,0x49DB,0xF7D7,
                  0xAAA8,0x2225,0x17BC,0x5E7A,0xF7DF,0xC0D3,0x2B76,0xCEFB,
                  0xDAA2,0x9712,0xBE81,0x77D9,0x6EBF,0x2829,0x21DF,0x7FAD,
                  0x5490,0x0655,0x1F86,0xDF2D,0x7797,0xD015,0x5AA9,0xB3F6,
                  0xAA4A,0x4529,0xBEF3,0xF7EA,0xEAF7,0x5454,0x25DE,0xDDDB,
                  0x4420,0x1626,0x3F6A,0xAAF7,0x530F,0xEA0A,0xA8A5,0x773D,
                  0x5280,0x0455,0x3A00,0xDF7A,0x7797,0xDA14,0x92B7,0xADFE,
                  0x4800,0x082A,0x7FFF,0xDAE8,0x461D,0x68B5,0x259A,0xBBBF,
                  0x0000,0x0AEB,0x749F,0x55FE,0xC41F,0x4B2A,0x12A9,0x56FD,
                  0x4000,0x0215,0x7FFE,0x883E,0x19FF,0x34CA,0xAB55,0x5D5B,
                  0x0000,0x0A54,0xEFFD,0x5297,0xFAC5,0x1B76,0xA22A,0xA7ED,
                  0x0000,0x5DF6,0x7F55,0x190D,0xF714,0xD5AB,0x5149,0x5AB7,
                  0x0005,0x0A7A,0xFF9A,0x2243,0x8652,0x2A56,0x9855,0x556B,
                  0x0050,0x4CC1,0x71C4,0x15A7,0x4449,0x42AD,0x5095,0x55BF,
                  0x0106,0x86E4,0xFFC5,0xED07,0xE550,0xAD56,0xA844,0xAD65,
                  0x0051,0x0CCC,0xFBCE,0x1DFA,0xB4A8,0x167F,0x502A,0x4ABF,
                  0x150E,0xB57C,0xFEFE,0x93F1,0xBD55,0x695A,0xF081,0x2595,
                  0x42BA,0xECEC,0xCFD1,0x9E3F,0x44CF,0xB3AA,0x242A,0x92AE,
                  0x0BDF,0x0979,0xEB93,0xF5F5,0xFD03,0x00D4,0xD488,0x2AB5,
                  0x757B,0xE9B8,0x9CE8,0x7FBE,0xC48D,0xD3E1,0x7022,0x92AB,
                  0x5FDF,0x0C4D,0x8BFC,0x1FEB,0xBD16,0x0205,0xA480,0x4955,
                  0x03FF,0xE0E9,0xF7EF,0xFF7E,0xFC4F,0xC483,0x5415,0x2495,
                  0xEF9F,0xF151,0x85FA,0xABDF,0xD805,0xD021,0x6800,0x9256,
                  0x60E4,0x7E38,0xEBBB,0xFEFA,0xBD65,0x7FEC,0xA844,0x0AAA,
                  0x21F6,0x0E51,0xBEEF,0xAEAA,0xB442,0x9542,0xD001,0x2255,
                  0xF8F8,0xEFD8,0xDEFA,0xFBDD,0xFC23,0x6EA7,0x6008,0x892A,
                  0x5D40,0x0839,0x47AF,0xBFAC,0x8E41,0xA903,0x8822,0x2093,
                  0x36F7,0x0619,0xAB21,0xE5FF,0x0412,0xAA06,0xB000,0x054A,
                  0x076C,0x8AD4,0xFF0F,0xBDA7,0xF422,0xE887,0x5000,0x9025,
                  0x8D86,0x8F77,0x74FD,0xF771,0xAF12,0xB415,0xA000,0x2292,
                  0x65A5,0xD4A0,0xB9BC,0xFF98,0xEA29,0xD51A,0x0002,0x000A,
                  0x8644,0x32A5,0xADED,0xD77F,0xE8B2,0x543C,0x0000,0x24B2,
                  0x0846,0x0D24,0xB57B,0x7EFC,0x7A39,0x6006,0x8000,0x000A,
                  0x0C30,0x325B,0x6F87,0xF51C,0x7D75,0xA84C,0xA200,0x92A1,
                  0x1320,0x8C20,0xDDB3,0xDAF0,0xF94C,0xD4B6,0x8000,0x0014,
                  0x0841,0x6012,0xEEFE,0xD549,0xC254,0xD02D,0x0800,0x0482,
                  0x1282,0x0262,0x557D,0xF56F,0x45A8,0xE8D5,0x4000,0x4029,
                  0x6104,0x5240,0x7E07,0xEB2B,0x5351,0xD1DC,0x1000,0x0484,
                  0x0002,0x8440,0x56FD,0xD8B4,0xCC69,0xC1F4,0x8480,0x0002,
                  0x0440,0x0901,0x7B19,0x6BAF,0x6E05,0x62A8,0x2000,0x0051,
                  0x0044,0x4028,0x9EFE,0xEFB9,0xFFAA,0x8ABA,0x0920,0x0004,
                  0x0102,0x8245,0x2FCF,0xBD6E,0x5D80,0xCB51,0x4000,0x0022,
                  0x1400,0x0401,0x57A0,0x43DB,0x26A8,0x0EF8,0x9484,0x0108,
                  0x0010,0x1001,0x3AD8,0x0B2F,0x50A2,0x4AAC,0x0000,0x0001,
                  0x0002,0x4009,0xCFFD,0x5380,0x800D,0x1DAF,0x5520,0x0012,
                  0x1000,0x8400,0xB573,0x3878,0x00AB,0x4D62,0x8000,0x8000,
                  0x0000,0x0049,0xD7FC,0xE64E,0x02DB,0x32E8,0xA948,0x0002,
                  0x0084,0x0000,0xEBC5,0x79F6,0xD53C,0x2F62,0x0200,0x0008,
                  0x2400,0x0005,0xD5F3,0x61AF,0xFC0C,0x3558,0x5091,0x0001,
                  0x0200,0x2010,0xEADF,0x7BFB,0x1238,0x778C,0x2904,0x0004,
                  0x0000,0x0009,0xF3F7,0xF0B8,0x1054,0xBD52,0xA420,0x0000,
                  0x0000,0x8052,0xF97F,0xFCB9,0xEDD0,0xE5C2,0x1510,0x1002,
                  0x0002,0x0025,0xF5DF,0xF7DE,0x7F79,0xFD00,0xE482,0x0008,
                  0x0000,0x005D,0xFD7F,0xFFDF,0x9012,0xBF9A,0x4A20,0x4000,
                  0x0000,0x0121,0xFD56,0xF0E7,0xF40B,0xBF41,0x1084,0x0401,
                  0x0800,0x01D9,0xFE5F,0xFFC3,0xB755,0xBFB2,0xDB20,0x0000,
                  0x0000,0x0413,0xFF95,0xFD77,0x3E87,0x7ADB,0xBD08,0x8009,
                  0x0000,0x1C71,0xF54A,0xFD1C,0x7E94,0xFEB8,0x6E40,0x0000,
                  0x0000,0x0C4B,0xFDC5,0xBFB7,0xFE0B,0xB5D5,0xFFD4,0x4000,
                  0x0000,0xA811,0xF3E0,0xFE3F,0x7D2E,0xDF7F,0xBDE1,0x0001,
                  0x0016,0x0449,0xFF72,0x5D3D,0xFC57,0x56D7,0xDBF8,0x0004,
                  0x0148,0xC808,0xFCFA,0xBEC7,0x757A,0xFBBD,0xFDFE,0x9000,
                  0x0AB5,0x8D05,0xEF7A,0x0FFE,0x94AF,0xADEF,0x6FFF,0x8002,
                  0x5310,0xA000,0xF1BE,0x916A,0x11F6,0xDB7B,0xD77F,0xF000,
                  0x0D0B,0x8C04,0xFDFE,0x22A8,0x4BAD,0xEFAF,0xF7FD,0xFC00,
                  0x4440,0xA1A4,0xFE6F,0x9AA2,0x9EFA,0x5FFD,0xBFFD,0xFF82,
                  0x0162,0x1382,0x7F9B,0x8DAF,0x7F57,0xDEB7,0xEDFF,0x57E0,
                  0x50A4,0x4D10,0xBEDF,0xE37F,0xFDEA,0xB7FF,0x7CF7,0xAEFC,
                  0xC200,0x8400,0xFBCD,0xF5FF,0xFFAD,0xDDAF,0xDFFA,0xB5BF,
                  0x7025,0xD240,0x7BB3,0xF8EF,0xD96B,0x7FFB,0xEDED,0x57D7,
                  0x210E,0xFB40,0x3B98,0xFD7D,0x77BD,0xBF6E,0xFEFA,0x906F,
                  0x3839,0xDE00,0x3F7F,0x5E8B,0xDD56,0xD7BF,0xBFFD,0x4B2A,

                  0x4921,0x0480,0x1000,0x0A00,0x0000,0x0000,0x0000,0x0000,
                  0x7288,0x4014,0x8248,0x1684,0x0249,0x1240,0x0100,0x1000,
                  0x95B4,0x9080,0x0000,0x0820,0x8000,0x4008,0x3004,0x4124,
                  0x0A03,0x4222,0x4803,0xD880,0x0400,0x1021,0x8000,0x0401,
                  0x2AE2,0x1208,0x0242,0xAE20,0x11C5,0x0100,0x0490,0x2084,
                  0xC401,0x0D04,0x500F,0x72AB,0x0062,0xC008,0x4002,0x0000,
                  0x4075,0x1055,0x04A1,0x3D40,0x04C4,0x2881,0x0010,0x8211,
                  0xB485,0x4A05,0x480D,0x24B1,0x2830,0x2006,0x0240,0x0844,
                  0xB0BA,0x70B1,0x144B,0xA942,0x6F28,0x5010,0x2A05,0x0000,
                  0x5545,0x8848,0x02BB,0x6838,0x02E6,0xD504,0x0820,0x4008,
                  0xEA00,0x40A2,0x416F,0x5348,0x02DA,0x2400,0x4001,0x1480,
                  0x5620,0x8408,0x8888,0xD0BB,0x1BAC,0x6A48,0x0864,0x8004,
                  0x0502,0x6040,0x0383,0x4B00,0x3579,0x1E24,0x5001,0x0090,
                  0x6B00,0x482B,0xA756,0xF10B,0xD94D,0x0001,0x8148,0x2900,
                  0x1088,0x0124,0x075B,0xB9A1,0xD1A8,0x8280,0x0402,0x000A,
                  0x402D,0x50A9,0x0CF9,0x0EFC,0x8D56,0x0F12,0x28A0,0x4108,
                  0x0208,0x0280,0x77EF,0xA097,0xD1DA,0x05B8,0x8209,0x08C0,
                  0xCD20,0xCA92,0x278A,0x06FB,0x82CA,0xBD98,0x2950,0x2088,
                  0x5584,0x2420,0xAEF4,0x2A00,0xD6E7,0x8504,0xA405,0x0A02,
                  0x7220,0x8204,0x4964,0x9F9C,0x7FFA,0xCF80,0x8952,0xA092,
                  0x9058,0x20A0,0x43ED,0xB1F1,0xAB1D,0x50C2,0x4550,0x4A20,
                  0x0062,0x8808,0x177B,0x03F9,0xE01A,0x3DEE,0x2483,0x6104,
                  0xB888,0x4042,0x7DE3,0xAE07,0xA20E,0x6670,0x5389,0x8CA9,
                  0x5122,0x5011,0xAF07,0x9E53,0x071F,0x20C0,0x0EAB,0x5250,
                  0xAC08,0x0446,0xFC06,0x3784,0x1D80,0x50FC,0x9A15,0x6B8A,
                  0x322A,0x8113,0x098B,0xD307,0xFFC5,0xE002,0x3B55,0x50A8,
                  0xA080,0x104F,0xC281,0x67CB,0x8020,0x947F,0xDAD5,0x8AA5,
                  0x4B08,0x4227,0xEF3B,0xB3FC,0x1110,0xBB68,0x5D0A,0xAA02,
                  0xA841,0x0108,0x46FF,0xE603,0xFFFC,0x1D9E,0x5BD3,0x4554,
                  0x0A08,0x14B8,0x7246,0xF711,0xFFF3,0xF8E3,0x6FED,0xFA22,
                  0x4080,0x2466,0x4C61,0x7D0F,0x1C7B,0x6380,0xCEEB,0x6F54,
                  0x1202,0x1300,0x4A18,0x0E1F,0xFFFC,0x8002,0xD9F5,0xE3EB,
                  0x4001,0x4907,0xEFE8,0x37A0,0x3E0D,0x33F6,0x4FE9,0xFD7B,
                  0x00A4,0x5500,0x34A4,0xBF40,0x0FF7,0x800C,0x3FBC,0xB6D2,
                  0x0412,0x9D83,0xF8D2,0x3EEC,0x0DAD,0x7431,0xCEBB,0xEBFA,
                  0x22A5,0x5B60,0x7B4C,0x055C,0x59BB,0xA05F,0xC3FB,0xFA62,
                  0x144A,0xBE08,0x018D,0x448F,0xB691,0x6680,0x17EE,0x55AF,
                  0x49A5,0x6834,0x358C,0x04F8,0x1C85,0x27FF,0x89EF,0x7DD5,
                  0x552E,0xDF58,0x6B15,0x814A,0x1006,0x881B,0xC7FE,0xF7F6,
                  0x4ADB,0x7D47,0x4402,0x80A8,0x8202,0x7A0F,0x17FD,0x7BFC,
                  0x5BF2,0x7CED,0x8A05,0x9000,0xC227,0xDBC0,0xBFFF,0xF7FF,
                  0xACDF,0xFEB7,0xF841,0x8000,0xA011,0x41DD,0x01AA,0xFAF8,
                  0x42FF,0xFE07,0xFA32,0x8023,0x5001,0xBCC0,0x4CDD,0xF76D,
                  0xFFEF,0xFFFF,0xE082,0x20FF,0xF900,0xD6F8,0xFF75,0xBABF,
                  0xFBBD,0x68AC,0x4023,0xD1FF,0xE810,0x231E,0x0DEE,0xDFD4,
                  0x66FF,0xD8F4,0x2209,0x45FD,0x7084,0x5BE1,0x60BB,0x5377,
                  0xFF7F,0x75DA,0xA085,0x8D7D,0x7C04,0x2880,0x06EF,0x6DFE,
                  0x8FFD,0xA9E6,0x0A54,0x03F6,0xB120,0xFB0F,0x5EB5,0x9BFF,
                  0xFF1B,0x500A,0xE300,0x1BBA,0xFE0B,0x9500,0x245A,0x6D5F,
                  0xFDFA,0xA5F2,0x90A4,0x8ADE,0xAC46,0xA6A0,0x10ED,0xBD6F,
                  0xFF24,0x51DC,0x2208,0x6FFF,0xFC02,0x5480,0x061B,0x6BFD,
                  0xBDB2,0x909D,0xCA4F,0xB77F,0xF401,0x5AFB,0x022D,0xBFFF,
                  0xD64A,0x4383,0x0097,0x43FF,0xCE01,0x6A8D,0x056A,0xAAEF,
                  0xF5A5,0x22F3,0xCC3C,0x4DEB,0xEE80,0x0AAF,0x05AA,0xDD2F,
                  0x4A50,0x0210,0x4956,0x5BF7,0xFD6A,0x9AE6,0x7E55,0x56ED,
                  0xA909,0x206E,0xF029,0x7FF7,0x7D80,0x2AA3,0x80A5,0x55BB,
                  0x5240,0x0163,0xF04A,0xFEBD,0x7BDB,0x6AC0,0xE3D2,0xAADE,
                  0x0810,0x0080,0x6864,0xFEBD,0xFFE0,0x6AF6,0x028A,0x56B7,
                  0xA240,0x1780,0x9100,0xFA55,0xFFE8,0x5583,0x8AA9,0x55AD,
                  0x1000,0x0780,0xA047,0xF75F,0xD798,0x3A84,0x7284,0x94DB,
                  0x4000,0x007B,0x4157,0xEAB7,0xFFC8,0xAAFE,0x8D52,0x5577,
                  0x0000,0x078A,0x8037,0xBFFF,0xF7B0,0x1D5E,0x8209,0x254D,
                  0x0000,0x0186,0x450E,0xF5FF,0x7FC0,0x27BE,0x32A2,0x52B6,
                  0x0000,0x4D80,0x8000,0x0FFA,0xAF62,0x9610,0x0810,0x8A5D,
                  0x0005,0x0941,0x8B60,0xAE2A,0x8C2A,0xA9BE,0xB124,0x2296,
                  0x0150,0xA9FE,0x8801,0x45C0,0x1880,0x6E60,0xB200,0x9455,
                  0x040A,0x59BD,0x9008,0xB7C8,0x2E30,0x4E1D,0x7602,0x02A5,
                  0x1155,0x7600,0x94A8,0xC3E2,0x98C0,0x7F01,0x7A20,0x292A,
                  0x48A1,0x9D81,0x1A70,0x1718,0xC178,0x80FD,0x3004,0x88AB,
                  0x2542,0x1F1C,0x2931,0x2309,0xC28D,0x6801,0xF800,0x2255,
                  0x13D3,0xD041,0x1E11,0x16FB,0x9BFF,0x07FC,0x0004,0x0824,
                  0xAA0A,0xAD45,0x0FBA,0xF883,0xB9FC,0x4B28,0x0200,0x210A,
                  0x5FA0,0x1FCD,0x2FF7,0x121B,0xD3FB,0xD408,0x4000,0x04A2,
                  0x17FF,0x2611,0x3FFF,0xC9AF,0xFA70,0x4E07,0x7E00,0x4009,
                  0xA3F8,0xAA9C,0x3F5B,0xCA7F,0xB3AC,0xD63B,0x0400,0x0144,
                  0xFE5C,0x1FDD,0x5DF8,0xAAFF,0x3252,0x28F8,0x2600,0x0012,
                  0x23F8,0x52FC,0x5FFE,0xFEEF,0xD369,0x57EB,0x0000,0x0209,
                  0x9971,0xCBB6,0x43EF,0x6F7F,0xE318,0x323A,0x3000,0x0000,
                  0x47F8,0xEC12,0x7FB3,0xBAFB,0xF55A,0x2DD7,0xD900,0x0055,
                  0x1712,0x8395,0x23FC,0xF9F7,0xF3EA,0x8016,0x0C10,0x0000,
                  0xDBA9,0x70DC,0x4BF7,0xAFFB,0x9B29,0x6AAC,0x0C40,0x0024,
                  0x0775,0x0897,0x2AFF,0xF5DF,0x6A94,0x115F,0xC000,0x0002,
                  0xAEEF,0xFFD8,0x9ABF,0x5DFB,0xE1DA,0x46C8,0xC248,0x0008,
                  0xCD5F,0xB8AC,0x500B,0xF77A,0x7AC5,0x57BB,0xF801,0x0002,
                  0xB047,0xD569,0x0A67,0xDBED,0x6B7F,0x17EF,0x0128,0x0000,
                  0x76DC,0x712C,0xCA5F,0xEAF9,0xE4BD,0x41C0,0x0480,0x1000,
                  0x93DF,0x2DF9,0x4108,0xDD6B,0x897C,0x2A50,0x4022,0x4002,
                  0x7FF3,0xF57A,0x5237,0xE8DA,0xFF19,0xEBD0,0x6A88,0x0010,
                  0xE79C,0xF68B,0x4833,0xF61D,0xF89E,0x9550,0x4120,0x0002,
                  0xBAEF,0x95F5,0x905D,0xB003,0xA3DE,0x56A6,0x0A09,0x2400,
                  0xEAD5,0xF54D,0x301F,0xEA60,0x041B,0x2F1A,0x12A0,0x0080,
                  0xFFDE,0x9FFE,0x1117,0xA03A,0x280E,0x2E9A,0xAC0A,0x0800,
                  0xEDFF,0x7F9C,0xAB8F,0xD08F,0xF003,0x137D,0x0940,0x8000,
                  0xAFFB,0xE4B4,0x80C3,0x0520,0x4DE6,0x2C30,0x8214,0x1000,
                  0xFFFF,0x7FDF,0x2817,0xA12F,0x7296,0x374C,0xCC09,0x4100,
                  0xFBBB,0x74FE,0x8409,0xDD79,0x7DEA,0x9D05,0x0450,0x1400,
                  0xFFFB,0xF7DE,0x6115,0xEFFE,0xDE15,0x7FEB,0x9BA4,0x8040,
                  0xFB6F,0x5FFA,0xD155,0xFFFE,0x707A,0x25AA,0x1520,0x2800,
                  0xFFFF,0x7BDE,0xE86F,0xCA7E,0xF947,0xF5B3,0xB00E,0x8200,
                  0xFFEF,0xEFFE,0xC530,0x1518,0xAF58,0x9C75,0x5240,0x2880,
                  0xFFFD,0xFFFE,0x3042,0x7E6F,0x7550,0xA6C9,0xFC0A,0x8020,
                  0xEFFF,0x7FBF,0x4AAC,0x0B05,0x5A41,0xA0D0,0x5488,0xA480,
                  0xFFFF,0xFFF4,0x2802,0x1BBB,0xEC76,0xE98E,0x2B1A,0x9000,
                  0xFF7B,0xFFF9,0x1461,0xC00C,0xD8EB,0x42C0,0x6888,0x4490,
                  0xDFFD,0xFB7C,0x2A04,0x10D3,0x8BE5,0xEBAD,0x4434,0x1000,
                  0xFDF7,0xFFEB,0x1535,0x8B24,0xED63,0x1C02,0xDB4C,0x82A0,
                  0xFFDF,0xEDF0,0x0C08,0x0087,0xEDBB,0xD0C8,0x8D72,0x1100,
                  0xF7FF,0xFFB1,0x0480,0x0367,0x588D,0x5AA8,0xB419,0x5410,
                  0xFFFF,0xB7C2,0x0A20,0x0961,0xA41E,0x97FD,0xF020,0x1080,
                  0xFFFE,0xFEB6,0x0280,0x1100,0x6ECF,0x703E,0x1068,0xC408,
                  0xFF6F,0xDBCE,0x02A9,0x4AB8,0x0BBC,0xD19F,0x39A0,0x9640,
                  0xF7FB,0x7676,0x09A0,0x0531,0x50A8,0x605F,0xF6AA,0x2010,
                  0xDD5F,0xC1EC,0x446A,0x001B,0x013C,0x1F87,0xF459,0x8940,
                  0xFFF7,0x42AE,0x02B5,0x005B,0xA97B,0x21CE,0xFE08,0xA400,
                  0x5BBD,0x56B4,0x022A,0x4166,0x01B6,0xCE7A,0x7E01,0x4090,
                  0xFFEA,0xA2EE,0x421F,0x05D5,0xD2C1,0x0209,0xBFA5,0x4800,
                  0x5452,0x03B6,0x0189,0xA2C8,0x032D,0xB908,0xA5E5,0x2480,
                  0xFE89,0x5777,0x2804,0x4240,0x8AD5,0x80C8,0x08FA,0x1020,
                  0xA0B2,0x86FA,0x11C5,0xF001,0x6B52,0x0330,0xDDAE,0x9900,
                  0x5548,0x4A6E,0x2C91,0x2E95,0xEC99,0x2416,0x3EDF,0xD800,
                  0x5520,0x027B,0x0729,0x9D57,0xB450,0x9870,0x8B3B,0xEC90,
                  0x5512,0x48DB,0x0080,0x4D5D,0x344D,0xE68B,0x43EF,0xBD84,
                  0xB4C9,0x04B9,0x9574,0x7759,0x8089,0x2908,0x32EF,0xFFE0,
                  0x2E90,0x0EEF,0x4155,0x1CA0,0x4B1D,0x4D14,0x045D,0xFF78,
                  0x1510,0x405B,0x1572,0x4E85,0x0070,0x7210,0x097F,0xFFF6,
                  0x2E85,0x8A6F,0x8642,0x8700,0x7394,0x0916,0x0A7F,0xBFFE,
                  0x4AA4,0x503B,0xC967,0x42C0,0x880A,0x5091,0x8C5F,0x77FF,
                  0x9514,0xC80F,0x44A8,0xB570,0xB3AB,0x2D12,0x45F6,0xDBFF,

                  0x4921,0x0480,0x1000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x7288,0x4014,0x8248,0x0404,0x0249,0x1240,0x0100,0x1000,
                  0x95B4,0x9480,0x0000,0x3400,0x8000,0x4008,0x2004,0x4124,
                  0x4A03,0x4222,0x4800,0xFE00,0x0400,0x1021,0x0000,0x0401,
                  0x2AEA,0x1248,0x0241,0xF000,0x0105,0x0100,0x0490,0x2084,
                  0xC401,0x4D04,0x5003,0xC801,0x03C2,0xC008,0x4002,0x0000,
                  0x4975,0x1055,0x04AF,0xC000,0x0384,0x2881,0x0010,0x8211,
                  0xB485,0x4A05,0x4812,0xD0A5,0x2601,0x2404,0x0240,0x0844,
                  0xB2BA,0x70B1,0x1435,0x4442,0x60E0,0x5010,0x2804,0x0000,
                  0x5545,0x8A48,0x0244,0x8038,0x8152,0xD500,0x0000,0x4008,
                  0xEA92,0x40A2,0x4080,0x834A,0x0020,0x2500,0x0001,0x0480,
                  0x5620,0x9408,0x8908,0x14BB,0x5A45,0x6A48,0x0824,0x0004,
                  0x954A,0x6140,0x002A,0x4344,0x3481,0x1E20,0x4000,0x0010,
                  0x6B01,0x482B,0xA041,0x012B,0xD831,0x4941,0x0100,0x2100,
                  0x54A8,0x0524,0x0104,0x11A5,0xD500,0xA280,0x0000,0x0002,
                  0x492D,0x50A9,0x0050,0x0EFC,0xAD4A,0x9F50,0x0000,0x0008,
                  0x5248,0x0280,0x4440,0x0297,0xD582,0x45B8,0x0000,0x0080,
                  0xCD22,0xCA92,0x1200,0x06FB,0xAA8A,0xBD98,0x0000,0x0000,
                  0x5594,0x2420,0x80E5,0x2AAA,0xD6E4,0x9554,0x0000,0x0000,
                  0x7222,0x8204,0x0052,0x1F9C,0xFFFA,0x4FA4,0x0000,0x0002,
                  0x9558,0x20A0,0x01C9,0xF5F3,0xAB1D,0x12D2,0x3200,0x0000,
                  0x4062,0x8A08,0x0323,0xABFD,0xF55A,0x9DEE,0x0048,0x0000,
                  0xBA88,0x4042,0x510B,0xAE57,0xAAAE,0x6675,0x4832,0x0000,
                  0x5122,0x5010,0x8257,0xBF5B,0x575F,0x29D2,0x2280,0x0000,
                  0xAC88,0x0440,0xD156,0xB7D5,0x5DA5,0x54FD,0x9052,0x8800,
                  0x322A,0x8001,0x01A9,0xDB4F,0xFFD5,0xC2A6,0x8A48,0x2480,
                  0xA080,0x1003,0xC291,0x6FEB,0xAAAA,0x817F,0xE102,0xA200,
                  0x4B08,0x4007,0x8772,0xB3FE,0x9552,0xAB6A,0xD4F8,0x10B8,
                  0xA841,0x0005,0x56E2,0xCEAB,0xFFFD,0x55BF,0x4E2D,0x5482,
                  0x0A08,0x001A,0xB141,0x3755,0xFFF0,0xEAEB,0x6292,0x2098,
                  0x4080,0x0017,0x2CC6,0x1D2F,0x5D78,0x69A5,0xEAB9,0x5540,
                  0x1200,0x0015,0x5127,0xE6BF,0xFFFE,0x44AA,0xDD5F,0x2C89,
                  0x4000,0x0057,0xEBD7,0xC525,0x3EAD,0x83F7,0x7D57,0x5220,
                  0x0000,0x022D,0x748B,0xC054,0xAFF6,0x00AD,0xB6AB,0xA94E,
                  0x0000,0x1557,0xF02D,0xC04A,0xACA0,0x86B5,0xEBEE,0xAE90,
                  0x0000,0x086A,0xFC23,0xF8AC,0x5800,0x415F,0xDAAA,0x95AD,
                  0x0002,0xA25D,0x5072,0xBB20,0x016E,0x26AA,0xBFAB,0xFEA4,
                  0x0008,0x967F,0x5472,0xFA07,0xA372,0x17FF,0xDBFD,0xD55A,
                  0x0145,0x57FD,0x40E8,0x7EB5,0xE5F8,0x095B,0xEF57,0xDD29,
                  0x082A,0xD7EF,0x2179,0x7F57,0x7DFD,0x36AF,0xBFEF,0xEED5,
                  0x254F,0xABFF,0x41F8,0x7FFF,0x7DF8,0x1BD5,0xFD7F,0xBEA5,
                  0x13AB,0x7FFF,0xF5BA,0x7FF8,0xBFEE,0x09CF,0xADFF,0xDFAF,
                  0xBD5A,0xAB6F,0xD5DC,0x7FE2,0x1FFE,0x0C6A,0xFEDD,0xBFD7,
                  0x2AAF,0xFFFF,0xEF7D,0x5DA8,0x56F7,0x0BFD,0xFF7F,0xBFED,
                  0x5557,0xF9FE,0x9FFC,0x2080,0x17FD,0x425F,0x5FEE,0xFEF7,
                  0x5FFF,0xD9FD,0x1FFE,0xB802,0x8F7F,0x856B,0xFABF,0xDBFC,
                  0x55D5,0x77FC,0xDFFE,0x7802,0x8FFF,0xC12A,0xAFEF,0x7FAD,
                  0xFBFD,0xABF7,0xF5FB,0xF009,0xCFDF,0x005F,0xFEB5,0xDBF6,
                  0x6F5B,0x5BDA,0x1DF5,0xF045,0x03F4,0x402D,0x765B,0x6FFB,
                  0xBDFA,0xA3FA,0x2FF5,0xF121,0x57F9,0x5075,0xBBED,0xBD7D,
                  0xFF24,0xFBFE,0x1BD0,0xD000,0x037D,0x0055,0x6F1B,0x69FF,
                  0xFDB0,0xDFDD,0xF5FA,0xC080,0x01FC,0x817F,0xB76D,0xBFF6,
                  0xD65B,0x6BB7,0x6FD2,0xA010,0x05F6,0x001F,0xDF6A,0xAAEB,
                  0xF5AF,0xBBFB,0xB3E8,0x2000,0x817E,0xA09F,0x6FAE,0xDDBF,
                  0x4AF5,0x6D5A,0x97D6,0xF020,0x2095,0x404F,0xFEF5,0x56EF,
                  0xAB52,0x7CFE,0x8BEA,0x0002,0x107A,0x8057,0xEEAC,0x15BB,
                  0x5B0A,0xBD77,0x8FD5,0x4140,0x0074,0x024B,0xF7F6,0xAADE,
                  0x5D47,0xDC5A,0x97E8,0x01C0,0x407F,0x80DE,0xD683,0x46B6,
                  0x871D,0x7F6D,0xAF80,0x05A8,0x022F,0x2817,0xDE89,0xD5AD,
                  0xBB6F,0xFE2A,0x9FC0,0x0A30,0x281F,0xC02E,0xF7D2,0xDCDB,
                  0x15B5,0xBB3F,0x3FA0,0x1D48,0x4057,0x547F,0xDF73,0x7777,
                  0xBBDF,0xEE1B,0x3F40,0x4000,0x001F,0xE21F,0xD753,0xADCD,
                  0xAD7F,0xFB2E,0x3F04,0x0A20,0x2217,0xD83F,0x7FEA,0x00B6,
                  0xB7FF,0xFB55,0x7FFF,0xD000,0x003D,0x681A,0xDA75,0xCE15,
                  0xFFFF,0xFDD5,0x7C9F,0x51FC,0xCC1F,0x49FF,0xFC72,0x8B96,
                  0xBFFF,0xF51E,0x7FFE,0x803E,0x11FF,0x2D75,0xF6AA,0x36F1,
                  0xFFFF,0xF55E,0x7FFD,0xD697,0xEEC2,0xEE9D,0x7FD7,0x5AB5,
                  0xFFFF,0xF7E8,0x7755,0x030D,0xB70B,0x7F55,0xFC96,0x8C6A,
                  0xFFFB,0xFD34,0xEB95,0xDF83,0x067D,0xD5FD,0x77AE,0x223F,
                  0xFFEF,0xBFC3,0x61C2,0xDB46,0x04BF,0xFD53,0xFF6A,0x8815,
                  0xFFFB,0xE8A6,0xD1C5,0x9506,0x6DF9,0x57FD,0x57BF,0x5ABE,
                  0xFFAF,0xBF8C,0xE05E,0x3BE8,0x05FB,0xE3A8,0xAFD5,0x944A,
                  0xFFF5,0x5E34,0xD014,0xB9E0,0x2DFD,0xCAA9,0x4F7E,0xDEC8,
                  0xBFFF,0xB7FC,0xE084,0x0E10,0x2D4F,0xB242,0xFFD5,0x2D58,
                  0xF7FA,0xDBE1,0xD001,0x5DC0,0x4D83,0x0111,0x2F77,0xD40E,
                  0xFEDD,0x5D60,0xC000,0xFD00,0x640D,0xD0E0,0xABDD,0x6D46,
                  0xABFA,0xA965,0xC000,0x4590,0x2D96,0x0601,0x5F7F,0xB4A3,
                  0xD575,0xCA81,0xA010,0x9200,0x1C07,0xC002,0xBBEA,0xDB6A,
                  0x57BA,0xE4C1,0xD04C,0x4108,0x0C85,0xD021,0xDFFF,0x6DFC,
                  0xAA49,0x2AE0,0xC007,0x0700,0x0D65,0x7FED,0x5FBB,0xF555,
                  0x55A4,0xA441,0xF408,0x1001,0x2C02,0x9541,0x27FE,0xDD8E,
                  0x5272,0x4A88,0xF000,0x0E00,0x9C43,0x6EA7,0xDFF7,0x76D7,
                  0x0D49,0x2A19,0x5500,0xA206,0x4661,0xA904,0xF7DD,0xDF64,
                  0xA457,0x5489,0xBA00,0x008A,0x2C22,0xA803,0xFFFF,0xFAB7,
                  0x5244,0x8254,0xF540,0x260D,0x1E30,0xE80F,0xAFFF,0x6FDA,
                  0x2494,0x2927,0x3EA8,0x1D98,0x0F32,0xB402,0xDFFF,0xDD6D,
                  0x4185,0x44A4,0xB890,0x22B1,0x6239,0xD515,0xFFFD,0xFFF7,
                  0x1650,0x3025,0xAF58,0x1FD1,0x825A,0x1413,0xBFFF,0xDB5D,
                  0x4104,0x8500,0xBD50,0x08A9,0x0A99,0x6029,0x7FFF,0xFFF7,
                  0x0820,0x1050,0x6ED2,0x455C,0xFDDD,0xA817,0x5FFF,0x6D5E,
                  0x4204,0x8482,0xCDA8,0x1097,0xF8A8,0xD01B,0x7FFF,0xFFEB,
                  0x0840,0x2012,0xEFD0,0x7568,0xC1AC,0xD05B,0xFFFF,0xFB7D,
                  0x0092,0x0240,0x57E8,0x25E0,0x4A50,0xE85F,0xBFFF,0xBFD6,
                  0x2100,0x400A,0x7E80,0xEE4B,0x11C1,0xD0B3,0xEFFF,0xFB7B,
                  0x0002,0x0440,0x56A8,0x7899,0x9C21,0xC14F,0xFF7F,0xFFFD,
                  0x0000,0x0001,0x7B10,0x32C6,0xA605,0x6056,0xDFFF,0xFFAE,
                  0x4040,0x4009,0x9FD4,0x1003,0x01AA,0x8BAF,0xFFFF,0xFFFB,
                  0x0102,0x0241,0x2F5A,0x0000,0x8D80,0xC1AC,0xBFFF,0xFFDD,
                  0x1400,0x0001,0x17EA,0x8281,0x82A8,0x04B5,0xFB7F,0xFEF7,
                  0x0000,0x0001,0x3BF8,0x1E07,0x70A0,0x4D77,0xFFFF,0xFFFE,
                  0x0002,0x4009,0xCFDF,0x7380,0x8002,0x0499,0xFEDF,0xFFED,
                  0x0000,0x0400,0xB5FB,0x3E28,0x0155,0x52DD,0xFFFF,0xFFFF,
                  0x0000,0x0043,0xD7FE,0xE45E,0x0176,0x249B,0x7FBF,0xFFFD,
                  0x0000,0x0000,0xEBE5,0xF9F2,0x1D28,0x12DD,0xFDFF,0xFFF7,
                  0x0400,0x0001,0xD5F7,0x70FC,0xFC14,0x232E,0xEF7E,0xFFFE,
                  0x0000,0x2018,0xEAFD,0xF17B,0xB220,0x1C67,0xFFFF,0xFFFB,
                  0x0000,0x0019,0xF3FF,0xF0B8,0x1030,0x90E5,0xDFFF,0xFFFF,
                  0x0000,0x8072,0xF97F,0xFE79,0x5A80,0x529D,0xFEFF,0xFFFD,
                  0x0002,0x0065,0xF5DF,0xFEFE,0x2498,0x9587,0xFB7D,0xFFF7,
                  0x0000,0x00FD,0xFD7F,0xFF5F,0x9002,0x703B,0xBDFF,0xFFFF,
                  0x0000,0x01A9,0xFD56,0xFAB7,0xF408,0x9581,0xFFFB,0xFFFE,
                  0x0800,0x01F9,0xFE5F,0xFED2,0xB740,0x6052,0xD7FF,0xFFFF,
                  0x0000,0x041B,0xFF95,0xFD62,0x2E84,0x1BA7,0xBEFF,0xFFF6,
                  0x0000,0x1451,0xF54A,0xFD55,0x5E91,0x21CA,0x6FBF,0xFFFF,
                  0x0000,0x0C4B,0xFFC5,0xBE92,0xFE02,0x8678,0x7FAB,0xFFFF,
                  0x0000,0xA811,0xF3E0,0xFEAB,0xFD00,0x2289,0xBDFF,0xFFFE,
                  0x0016,0x1449,0xFF72,0x5F7D,0xFC05,0x9128,0x9BFB,0xFFFB,
                  0x0148,0xC808,0xFCF8,0xBEC7,0x7550,0x80CA,0x1FFF,0x7FFF,
                  0x0AB5,0xAD05,0xFFFA,0x0FFE,0x9402,0x0330,0xCFFF,0xFFFD,
                  0x5314,0xB000,0xF5BE,0x116A,0x1090,0x0096,0x377F,0xF7FF,
                  0x0D4A,0xAD04,0xFFFE,0x42A8,0x4802,0x8870,0x87FD,0xFFFF,
                  0x4454,0xA1A4,0xFEEF,0x8800,0x1448,0x468B,0x47FD,0xFFFD,
                  0x0162,0x5282,0x7BBB,0x8509,0x0001,0x0948,0x35FF,0x57FF,
                  0x50AD,0x6D10,0xBFD7,0xE020,0x4918,0x0514,0x8FF7,0xAEFB,
                  0x8242,0x9480,0xFB6D,0xF485,0x0020,0x5250,0x2DFA,0xB5BE,
                  0x7035,0xD2C0,0x7FB3,0xF800,0x7300,0x0916,0x1CED,0x17D7,
                  0x614E,0xF9C0,0x3ADA,0xFD42,0x0008,0x1091,0x8FFA,0x186F,
                  0x3839,0xDEA0,0x3F6F,0x5E80,0x9102,0x0552,0x5FFC,0x6F2A,

                  0xB6DE,0xFB7F,0xEFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
                  0x8D77,0xBFEB,0x7DB7,0xFFFB,0xFDB6,0xEDBF,0xFEFF,0xEFFF,
                  0x6A4B,0x6B7F,0xFFFF,0xFFFF,0x7FFF,0xBFF7,0xDFFB,0xBEDB,
                  0xB5FC,0xBDDD,0xB7FF,0xFFFF,0xFBFF,0xEFDE,0xFFFF,0xFBFE,
                  0xD515,0xEDB7,0xFDBF,0xFFFF,0xFFFA,0xFEFF,0xFB6F,0xDF7B,
                  0x3BFE,0xB2FB,0xAFFF,0xFFFE,0xFFFD,0x3FF7,0xBFFD,0xFFFF,
                  0xB68A,0xEFAA,0xFB5F,0xFFFF,0xFFFB,0xD77E,0xFFEF,0x7DEE,
                  0x4B7A,0xB5FA,0xB7FF,0xFF5A,0xDFFE,0xDBFB,0xFDBF,0xF7BB,
                  0x4D45,0x8F4E,0xEBFF,0xFFBD,0x9FFF,0xAFEF,0xD7FB,0xFFFF,
                  0xAABA,0x75B7,0xFDFF,0xFFC7,0x7FFD,0x2AFF,0xFFFF,0xBFF7,
                  0x156D,0xBF5D,0xBFFF,0xFCB5,0xFFFF,0xDAFF,0xFFFE,0xFB7F,
                  0xA9DF,0x6BF7,0x77F7,0xEB44,0xA5FA,0x95B7,0xF7DB,0xFFFB,
                  0x6AB5,0x9EBF,0xFFD5,0xBCBB,0xCBFE,0xE1DF,0xBFFF,0xFFEF,
                  0x94FE,0xB7D4,0x5FBF,0xFED4,0x27FE,0xB6BE,0xFEFF,0xDEFF,
                  0xAB57,0xFADB,0xFEFF,0xEE5A,0x2AFF,0x5D7F,0xFFFF,0xFFFD,
                  0xB6D2,0xAF56,0xFFAF,0xF103,0x52BD,0x60AF,0xFFFF,0xFFF7,
                  0xADB7,0xFD7F,0xBBBF,0xFD68,0x2A7D,0xBA47,0xFFFF,0xFF7F,
                  0x32DD,0x356D,0xFDFF,0xF904,0x5575,0x4267,0xFFFF,0xFFFF,
                  0xAA6B,0xDBDF,0x7F1A,0xD555,0x291B,0x6AAB,0xFFFF,0xFFFF,
                  0x8DDD,0x7DFB,0xFFAD,0xE063,0x0005,0xB05B,0xFFFF,0xFFFD,
                  0x6AA7,0xDF5F,0xFE36,0x0A0C,0x54E2,0xED2D,0xFFFF,0xFFFF,
                  0xBF9D,0x75F7,0xFCDC,0x5402,0x0AA5,0x6211,0xFFFF,0xFFFF,
                  0x4577,0xBFBD,0xAEF4,0x51A8,0x5551,0x998A,0xFFFF,0xFFFF,
                  0xAEDD,0xAFEF,0x7DA8,0x40A4,0xA8A0,0xD62D,0xFFFF,0xFFFF,
                  0x5377,0xFBBF,0x2EA9,0x482A,0xA25A,0xAB02,0x7FFF,0xFFFF,
                  0xCDD5,0x7FFE,0xFE56,0x24B0,0x002A,0x3D59,0x7FFF,0xFFFF,
                  0x5F7F,0xEFFC,0x3D6E,0x9014,0x5555,0x7E80,0x3FFF,0xFFFF,
                  0xB4F7,0xBFF8,0x788D,0x4C01,0x6AAD,0x5495,0x3FFF,0xFFFF,
                  0x57BE,0xFFFA,0xA91D,0x3154,0x0002,0xAA40,0xBFFF,0xFFFF,
                  0xF5F7,0xFFE5,0x4EBF,0xC8AA,0x000F,0x1514,0x9FFF,0xFFFF,
                  0xBF7F,0xFFE8,0xD33F,0xE2D0,0xA287,0x965A,0x1FFF,0xFFFF,
                  0xEDFF,0xFFEA,0xAEDF,0xD940,0x0001,0xFB55,0x2FFF,0xFFFF,
                  0xBFFF,0xFFA8,0x143F,0xFADA,0xC152,0x7C08,0x8FFF,0xFFFF,
                  0xFFFF,0xFFD2,0x8B7F,0xFFAB,0x5009,0xFF52,0x4FFF,0xFFFF,
                  0xFFFF,0xFFA8,0x0FFF,0xFFB5,0x535F,0xF94A,0x17FF,0xFFFF,
                  0xFFFF,0xFF95,0x03FF,0xFFD3,0xA7FF,0xFEA0,0x27FF,0xFFFF,
                  0xFFFF,0xFFA2,0xAFFF,0xFFFF,0xFFFF,0xD955,0x47FF,0xFFFF,
                  0xFFFF,0xFF80,0xABFF,0xFFFF,0xFFFF,0xE800,0x27FF,0xFFFF,
                  0xFFFF,0xFE02,0xBFFF,0xFFFF,0xFFFF,0xF6A4,0x13FF,0xFFFF,
                  0xFFFF,0xFE10,0xDFFF,0xFFFF,0x7FFF,0xC950,0x43FF,0xFFFF,
                  0xFFFF,0xFE00,0xBFFF,0xFFFF,0x7FFF,0xE42A,0x03FF,0xFFFF,
                  0xFFFF,0xFE00,0x0FFF,0xFFF8,0xBFEF,0xF630,0x53FF,0xFFFF,
                  0xFFFF,0xFE90,0x2FFF,0xFFE2,0x1FFF,0xF395,0x00DD,0xFFFF,
                  0xFFFF,0xFC00,0x1FFF,0xFDA8,0x57F7,0xF402,0x017F,0xBFFF,
                  0xFFFF,0xFA01,0x7FFF,0xF080,0x17FD,0xFDA0,0xA1EE,0xFFFF,
                  0xFFFF,0xDA02,0xFFFF,0xF800,0x0FFF,0xFA94,0x05BF,0xDBFF,
                  0xFFFF,0x7403,0x7FFF,0xF800,0x0FFF,0xFED5,0x50EF,0x7FFF,
                  0xFFFD,0xA808,0xFFFB,0xF000,0x0FFF,0xFFA0,0x01B5,0xDBFF,
                  0xFF5B,0x5025,0xFFF5,0xF000,0x03FF,0xFFD2,0x895B,0x6FFF,
                  0xFDFA,0xA005,0xFFF5,0xF000,0x17FF,0xFF8A,0x44ED,0xBD7F,
                  0xFF24,0x5001,0xFFD0,0xD000,0x037F,0xFFAA,0x909B,0x6BFF,
                  0xFDB0,0x9022,0x3FFA,0xC000,0x01FF,0xFE80,0x48AD,0xBFFF,
                  0xD64A,0x4048,0xBFD2,0xA010,0x05FF,0xFFE0,0x216A,0xAAEF,
                  0xF5A5,0x2004,0x7FE8,0x2000,0x81FF,0xFF60,0x91AA,0xDDBF,
                  0x4A50,0x02A5,0x7FD6,0xF020,0x20FF,0xFFB0,0x0155,0x56EF,
                  0xA900,0x2301,0x7FEA,0x0002,0x107F,0xFFA8,0x11A4,0x15BB,
                  0x5200,0x0288,0x7FD5,0x4000,0x007F,0xFDB4,0x08D2,0xAADE,
                  0x0800,0x03A5,0x7FE8,0x0000,0x407F,0xFF21,0x2982,0x46B7,
                  0x8200,0x1492,0x7F80,0x0000,0x022F,0xFFE8,0x2189,0x55AD,
                  0x1000,0x05D5,0x7FC0,0x0080,0x001F,0xFFD1,0x0980,0x94DB,
                  0x0000,0x01C0,0xFFA0,0x0000,0x4057,0xFF80,0x2152,0x5577,
                  0x0000,0x05E4,0xFF40,0x0000,0x001F,0xFFE0,0x2801,0x254D,
                  0x0000,0x01D1,0xFF04,0x0000,0x2217,0xFFC0,0x80A2,0x00B6,
                  0x0000,0x0DAA,0xFFFF,0xD000,0x003F,0xFFE5,0x2410,0x8A15,
                  0x0000,0x0BAA,0xFFFF,0xFFFC,0xCC1F,0xF600,0x0220,0x0296,
                  0x0000,0x0BE1,0xFFFF,0xFFFE,0x11FF,0xD28A,0x0800,0x1451,
                  0x0000,0x0BE1,0xFFFD,0xE97F,0xEEFD,0x1162,0x8202,0x02A5,
                  0x0000,0x01F7,0xF7FF,0xFCFF,0xB7F4,0x80AA,0x0000,0x082A,
                  0x0004,0x03AB,0xEBEA,0x207F,0x0782,0x2A02,0x8804,0x002B,
                  0x0010,0x43DD,0xE1FD,0x14BE,0x0740,0x02AC,0x0000,0x0015,
                  0x0004,0x15A5,0xD1FC,0x6BFE,0x0E06,0xA802,0xA804,0x0824,
                  0x0050,0x4187,0xE05F,0xC5E8,0x4600,0x1C57,0x5000,0x000A,
                  0x000A,0xA1B7,0xD014,0x59E0,0x0E05,0x3D56,0xB000,0x0480,
                  0x4000,0x49FF,0xE084,0x0F80,0x0EBF,0xFDBD,0x0000,0x0008,
                  0x0805,0x25E7,0xD001,0x5FC0,0x0E7F,0xFEEE,0xD000,0x0004,
                  0x0122,0xA3E7,0xC000,0xFD00,0x07FF,0xFF1F,0x5400,0x0002,
                  0x5405,0x56E3,0xC000,0x4580,0x0E7F,0xF9FE,0xA400,0x0001,
                  0x2A8A,0x3587,0xA000,0x0280,0x0FFF,0xFFFD,0x4000,0x0000,
                  0xA845,0x1B47,0xD000,0x0008,0x0F7F,0xFFFE,0x2000,0x0054,
                  0x55B6,0xD567,0xC000,0x0000,0x0E9F,0xFFFA,0xA800,0x0000,
                  0xAA5B,0x5BE7,0xF400,0x4001,0x2FFF,0xFFFE,0xD000,0x0004,
                  0xAD8D,0xB55F,0xF000,0x0000,0x9FBF,0xFFF8,0x2000,0x0002,
                  0xF2B6,0xD5E7,0xD500,0x0006,0x479F,0xFFFB,0x0800,0x0000,
                  0x5BA8,0xAB7F,0xFA00,0x080A,0x2FDF,0xFFFC,0x1000,0x0002,
                  0xADBB,0x7DAF,0xF540,0x000D,0x1FCF,0xFFF0,0x5000,0x0000,
                  0xDB6B,0xD6DD,0xFEA8,0x0018,0x0FCF,0xFFFD,0xA000,0x0000,
                  0xBE7A,0xBB5B,0xF890,0x0031,0x13C7,0xFFEA,0x0000,0x0002,
                  0xE9AF,0xCFDB,0xFF58,0x0051,0x83A7,0xFFEC,0x4000,0x0010,
                  0xBEFB,0x7AFF,0xFD50,0x0129,0x0B67,0xFFD6,0x8000,0x0002,
                  0xF7DF,0xEFAD,0xFED2,0x0A9F,0xFE23,0xFFE8,0xA000,0x0000,
                  0xBDFB,0x7B7D,0xFDA8,0x0518,0xFF57,0xFFE4,0x8000,0x0000,
                  0xF7BF,0xDFED,0xFFD0,0x0A8E,0xFE53,0xFFA5,0x0000,0x0000,
                  0xFF6D,0xFDBF,0xFFE8,0x0A10,0x75AF,0xFFA1,0x4000,0x0000,
                  0xDEFF,0xBFF7,0xFE80,0x1094,0x9E3F,0xFF4C,0x1000,0x0000,
                  0xFFFD,0xFBBF,0xFEA8,0x0640,0x1FDF,0xFEB0,0x0080,0x0000,
                  0xFFFF,0xFFFF,0xFF10,0x0000,0x27FF,0xFFA9,0x2000,0x0000,
                  0xBFBF,0xBFF7,0xFFD4,0x0000,0x01FF,0xF450,0x0000,0x0000,
                  0xFEFD,0xFDBF,0xFF5A,0x0001,0x01FF,0xFE53,0x4000,0x0000,
                  0xEBFF,0xFFFF,0xFFEA,0x8281,0x83FF,0xFB48,0x0480,0x0000,
                  0xFFFF,0xFFFF,0xFFF8,0x1E07,0xFFFF,0xF288,0x0000,0x0000,
                  0xFFFD,0xBFF7,0xFFDF,0x7DFF,0xFFFD,0xFB62,0x0120,0x0000,
                  0xFFFF,0xFBFF,0xFFFB,0x31D7,0xFEAA,0xED22,0x0000,0x0000,
                  0xFFFF,0xFFBF,0xFFFE,0xFDFF,0xFE89,0xDB64,0x8040,0x0000,
                  0xFFFF,0xFFFF,0xFFE5,0xF9F9,0x1DD7,0xED22,0x0200,0x0000,
                  0xFBFF,0xFFF9,0xFFF7,0x70FC,0xFFEB,0xDCD1,0x1081,0x0000,
                  0xFFFF,0xDFE9,0xFFFD,0xF17F,0xFFDF,0xE398,0x0000,0x0000,
                  0xFFFF,0xFFF9,0xFFFF,0xF0BF,0xFFCF,0x6F1A,0x2000,0x0000,
                  0xFFFF,0x7FB3,0xFFFF,0xFE7E,0xA57F,0xAD42,0x0100,0x0000,
                  0xFFFD,0xFFE7,0xFFFF,0xFEFF,0xDB67,0x6A40,0x0482,0x0000,
                  0xFFFF,0xFFFF,0xFFFF,0xFF5F,0xFFFD,0x8FDA,0x4200,0x0000,
                  0xFFFF,0xFFEF,0xFFFF,0xFAB7,0xFFF7,0x6A79,0x0004,0x0000,
                  0xF7FF,0xFFFF,0xFFFF,0xFED2,0xB7FF,0x9FAE,0xD800,0x0000,
                  0xFFFF,0xFBFF,0xFFFF,0xFD62,0x2FFB,0xE459,0xBD00,0x0000,
                  0xFFFF,0xEBFF,0xF5FF,0xFD55,0x5FEE,0xDE35,0x6E40,0x0000,
                  0xFFFF,0xF3FF,0xFFFF,0xFE92,0xFFFD,0x7987,0xFF94,0x0000,
                  0xFFFF,0x57FF,0xF3FF,0xFEAB,0xFFFF,0xDD76,0x7DE0,0x0000,
                  0xFFE9,0xEBFF,0xFF7F,0xFF7D,0xFFFA,0x6ED7,0x7FF8,0x0000,
                  0xFEB7,0x37FF,0xFCFF,0xFEC7,0xFFAF,0x7F35,0xFFFE,0x8000,
                  0xF54A,0x53FF,0xFFFF,0xFFFF,0xFFFD,0xFCCF,0x3FFF,0x8000,
                  0xACEB,0x4EFF,0xF5BF,0xFFFF,0xFF6F,0xFF69,0xCFFF,0xF000,
                  0xF2B5,0x52FF,0xFFFF,0xFFFF,0xFFFD,0x778F,0x7FFD,0xFC00,
                  0xBBAB,0x5EFF,0xFEEF,0xF7FF,0xEBB7,0xB974,0xBFFD,0xFF80,
                  0xFE9D,0xADFF,0xFBBB,0xFAF6,0xFFFE,0xF6B7,0xCFFF,0x57E0,
                  0xAF52,0x927F,0xFFD7,0xFFDF,0xB6E7,0xFAEB,0x7FF7,0xAEF8,
                  0x7DBD,0x6B7F,0xFB6D,0xFB7A,0xFFDF,0xADAF,0xDFFA,0xB5BE,
                  0x8FCA,0x2D7F,0xFFB3,0xFFFF,0x8CFF,0xF6E9,0xEFED,0x17D7,
                  0x9EB1,0x063F,0xFADA,0xFFBD,0xFFF7,0xEF6E,0x7FFA,0x106F,
                  0xC7C6,0x215F,0xFF6F,0x5FFF,0x6EFD,0xFAAD,0xBFFC,0x4B2A,

                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x5200,0x0000,0x0000,0x0400,0x0000,0x0000,0x0000,0x0000,
                  0x0090,0x8400,0x0000,0x2000,0x0000,0x0000,0x1000,0x0000,
                  0x4802,0x0000,0x0002,0xDA00,0x0000,0x0000,0x8000,0x0000,
                  0x0248,0x0240,0x0000,0xA000,0x0100,0x0000,0x0000,0x0000,
                  0x4000,0x4800,0x000B,0x4000,0x0142,0x4000,0x0000,0x0000,
                  0x0921,0x0004,0x0001,0x0000,0x0280,0x0000,0x0000,0x0000,
                  0x9004,0x0001,0x0800,0x40A5,0x0001,0x2402,0x0000,0x0000,
                  0x2290,0x5010,0x0001,0x0000,0x2020,0x0000,0x0201,0x0000,
                  0x0001,0x0240,0x0000,0x0028,0x8042,0x5004,0x0820,0x0000,
                  0xAA92,0x0000,0x0000,0x0242,0x0800,0x0500,0x4000,0x1000,
                  0x0000,0x1000,0x0000,0x1412,0x4205,0x2000,0x0040,0x8000,
                  0x9448,0x4100,0x002A,0x4144,0x1000,0x0A04,0x1001,0x0080,
                  0x2101,0x0001,0x0040,0x0421,0x4801,0x4940,0x8048,0x0800,
                  0x4420,0x0424,0x0100,0x1104,0x8510,0x2000,0x0402,0x0008,
                  0x0908,0x0000,0x0010,0x44A8,0x2842,0x9542,0x28A0,0x4100,
                  0x5040,0x0080,0x0441,0x0205,0x4500,0x4090,0x8209,0x0840,
                  0x4402,0x4200,0x0200,0x1251,0x288A,0x1508,0x2950,0x2088,
                  0x0110,0x0000,0x00A5,0x48AA,0x4440,0x9050,0xA405,0x0A02,
                  0x5002,0x0000,0x1252,0x0508,0xAAAA,0x4524,0x8952,0xA090,
                  0x0510,0x0000,0x2488,0xD4A2,0x8208,0x1290,0x5550,0x4A20,
                  0x4040,0x0200,0x4222,0xA955,0x3552,0x88A4,0x248B,0x2104,
                  0x1200,0x4000,0x1109,0x0454,0x88A4,0x4425,0x52A8,0x8CA9,
                  0x4000,0x0000,0x8252,0xB50A,0x524A,0x2992,0x2AAB,0x5250,
                  0x0888,0x0004,0x5154,0x92D1,0x4925,0x0455,0x1A55,0x4A8A,
                  0x2000,0x0111,0x2521,0x4A4D,0x5551,0x52A4,0xAB55,0x54A8,
                  0x0000,0x004A,0x9094,0x2AA1,0x2A8A,0x812A,0x9AD5,0xAAA5,
                  0x4100,0x0225,0x0652,0x9156,0x8452,0x2A42,0x955A,0xAA92,
                  0x0800,0x0105,0x52A2,0x4CA9,0x5549,0x4135,0x5EDB,0x5554,
                  0x0000,0x14B2,0xA910,0x2244,0xAAA4,0xAA4A,0x2BAD,0xBAAA,
                  0x0000,0x2455,0x2AC8,0x952A,0x4928,0x4925,0xAEFB,0x6D54,
                  0x0002,0x1315,0x5120,0x24AA,0xAAA6,0x14A8,0x4DDF,0x6BAB,
                  0x0001,0x4952,0x8A80,0x0925,0x14A9,0x8953,0x3FEB,0xFD69,
                  0x00A4,0x552D,0x6A50,0x8094,0xAAA4,0x54A5,0xA7BD,0xB6D6,
                  0x0412,0x9555,0x5100,0x154A,0xA492,0x0294,0xAFFF,0xEFDA,
                  0x22A5,0x5B4A,0xAC94,0x0225,0x1244,0x154A,0x9BFB,0xDAEA,
                  0x144A,0xB655,0x5200,0x0050,0x4800,0xAA2A,0xAFEF,0x7FAD,
                  0x49A5,0x6A5B,0x5A89,0x0100,0x4008,0x9555,0x5BFF,0xFDDD,
                  0x552E,0xDEED,0x4402,0x0048,0x0A01,0x2152,0xABFF,0xFF76,
                  0x4ADB,0xFFAA,0xAA84,0x8000,0x0000,0x96AA,0xAFFF,0xFFFD,
                  0x5B77,0x7D5B,0x5402,0x0000,0x4022,0x2955,0x6BFF,0xFFB7,
                  0xADDF,0xFF6C,0xA204,0x8005,0xE000,0xAA8B,0xADFF,0xFFFD,
                  0x56FF,0xFF6B,0x5021,0x0016,0xB000,0x486A,0xB7FF,0xFFEF,
                  0xBFEF,0xFD55,0x5080,0x8028,0x4000,0x2BAD,0x55FF,0xFFFF,
                  0xFBBF,0xFD5A,0xA002,0x4A00,0x0002,0x9455,0x57FF,0xFFF6,
                  0x6FFF,0xFDAD,0x4000,0x0002,0x8004,0x254B,0xBAFB,0xFFFF,
                  0xFFFF,0xFEB4,0x8000,0x8202,0x8800,0x152A,0xABFF,0xFFFE,
                  0xDFFF,0xFF55,0x0200,0x0809,0x4100,0x44DA,0xA8FF,0xFFFF,
                  0xFFFF,0xFFDA,0x200A,0x0445,0x0001,0x2AAD,0x76FF,0xFFFF,
                  0xFFFF,0xFAA9,0x400E,0x0121,0x4402,0x0975,0xABFF,0xFFFF,
                  0xF7FF,0xFF76,0x8425,0x0000,0x0000,0xAA55,0x6B7F,0xFFFF,
                  0xFFFD,0xFF49,0x4200,0x0880,0x0202,0x2556,0xB57F,0xFFBF,
                  0xFFFF,0xFEB5,0x5038,0x1410,0x1408,0x955B,0xDFFF,0xFFFF,
                  0xFFFF,0xFF5A,0x8402,0x9210,0x8001,0x555A,0x6BFF,0xFFFF,
                  0xFFFF,0xFD4A,0xA02B,0x0028,0x0040,0x254D,0xAAFF,0xFFFF,
                  0xFFF6,0xFEBA,0x943C,0x8000,0x0205,0x5556,0xEEFE,0xBFFF,
                  0xFFBF,0xFED6,0xA020,0x0140,0x8000,0x956B,0x55FF,0xFFFF,
                  0xFFEF,0xFD5A,0x8032,0x0142,0x4040,0x559A,0xD6F7,0xEFFF,
                  0xDFBF,0xFE6D,0xD055,0x05A8,0x0238,0x8255,0x54DF,0xFFFF,
                  0xFFFF,0xFE2A,0x4028,0x0AA0,0x2830,0x156E,0xD7FB,0xFFFF,
                  0xBFFF,0xFEAD,0x0000,0x1548,0x4060,0x0155,0x57FF,0xFFFF,
                  0xFFFF,0xFE53,0x4008,0x4000,0x0000,0x08AB,0xD5F7,0xFFFF,
                  0xFFFF,0xFE2C,0x80A0,0x0A20,0x2200,0x0255,0x5FFF,0xADFF,
                  0xFFFF,0xBA55,0x0000,0x0000,0x4000,0x015A,0xD3FF,0xFFBF,
                  0xFFFA,0xFC55,0x0000,0x0429,0x968A,0x1D6B,0x5CFB,0xDFFF,
                  0xFEAF,0x5414,0x0800,0x3200,0xB480,0xA555,0xE7FF,0x7FFB,
                  0xFBF5,0xAC16,0x8008,0x0AA0,0x3B0A,0xAA94,0x2BFF,0xFFFF,
                  0xEEAA,0xDC09,0x1C02,0x2510,0xD02B,0x5555,0xD5DF,0xDEFF,
                  0xB75B,0x6854,0x0E15,0xCAA4,0x10D5,0x5554,0x57FF,0x777F,
                  0xDAED,0xAA02,0xB30A,0xC950,0x293B,0xD553,0x57FF,0xDDBF,
                  0xED2A,0xAB0A,0x3029,0x8402,0x6150,0x5555,0x57FF,0xFFFF,
                  0x55A5,0x561E,0x100B,0x1A94,0x42AB,0xA2A8,0xADFF,0xDEFF,
                  0xB555,0x5106,0x001C,0xFC00,0x2151,0x42A5,0x4FFF,0xFFDD,
                  0xAAAA,0x9502,0x0080,0x1850,0x0140,0x0252,0xA5FF,0xBFFE,
                  0x5552,0x5402,0x0081,0x6040,0x4150,0x2910,0x2FFF,0xFEBF,
                  0x5489,0x4982,0x2005,0x2800,0xC120,0x04A6,0xA9FF,0xFFEF,
                  0x8952,0xA942,0x0000,0x0490,0x2180,0xAA11,0x5BFF,0xFDF7,
                  0x6424,0x94C8,0x1410,0x9280,0x10A8,0x0944,0x9FFF,0xFFFF,
                  0x1292,0x4284,0x004C,0x450C,0x02A0,0x0209,0x4EFF,0xFFFE,
                  0xA849,0x284A,0x0803,0x0608,0x0150,0x0005,0x5BEF,0xFFFF,
                  0x0504,0x8562,0x0008,0x5000,0x0094,0x0011,0x23BF,0xFFDF,
                  0x5022,0x5210,0x0400,0x0A00,0x0948,0x8005,0x5FFF,0xFFFF,
                  0x0550,0x0806,0x2040,0xA200,0x0864,0x1034,0xB5B7,0xFFF7,
                  0x2005,0x454A,0x0120,0x088F,0x0128,0x0242,0xB7FE,0xFFFF,
                  0x4A90,0x2212,0x0088,0x2417,0x80A2,0x0095,0xAED7,0xFFFF,
                  0x0025,0x0886,0x4008,0x1514,0x0450,0x0A2A,0x5B7F,0xEFFF,
                  0x4880,0x4226,0x0225,0x2280,0x70AA,0x00A5,0xBFDD,0xBFFF,
                  0x0208,0x2804,0x0080,0x1574,0x8054,0x4013,0x9577,0xFFFF,
                  0x1021,0x0150,0x0018,0x09CA,0x0948,0x0AA9,0x3EDF,0xFFFF,
                  0x4100,0x4803,0x0120,0x4FC0,0x2154,0x0115,0x57F6,0xDBFF,
                  0x040A,0x0292,0x1000,0x158F,0x02A8,0x0453,0x6D5F,0xFF7F,
                  0x0020,0x2001,0x0038,0x5FCD,0x15A5,0x0148,0x5BF5,0xF7FF,
                  0x0080,0x8041,0x0118,0x2F70,0x4A54,0x0457,0xB6BF,0x7FFF,
                  0x1000,0x090B,0x0114,0xBADF,0xA148,0x0293,0x6DEB,0xEFFF,
                  0x0000,0x0020,0x8040,0x5ED0,0x8120,0x0947,0xB776,0xBEFF,
                  0x0004,0x8200,0x0044,0x2286,0xA410,0x0052,0xDBAF,0xEBFF,
                  0x0000,0x0801,0x003E,0x1001,0x2040,0x0AAE,0x6D7B,0x7FBF,
                  0x0490,0x2000,0x01E0,0x0001,0x8E05,0x1104,0xAADF,0xD7FF,
                  0x1000,0x8020,0x4030,0x2700,0x0410,0x04B4,0xDB75,0x7DFF,
                  0x0000,0x0000,0x0012,0xA0A0,0x0005,0x2926,0xADBF,0xD77F,
                  0x0002,0x0000,0x0060,0xD210,0x0AA2,0x449D,0x56D5,0x7FDF,
                  0x0000,0x0040,0x0020,0x4CAA,0xA515,0x124D,0xAB77,0xDB7F,
                  0x0000,0x0002,0x0001,0x000A,0x1152,0x2499,0x7DAD,0x6FFF,
                  0x0000,0x0006,0x0053,0x4403,0x1028,0x925D,0x9577,0xBB6F,
                  0x0002,0x0480,0x0008,0x8B80,0x8812,0x210A,0xEB5A,0xEFFF,
                  0x0008,0x0010,0x0017,0x05A0,0x00A4,0x9475,0x2DB7,0x7D5F,
                  0x0020,0x1200,0x0000,0x05C0,0x0210,0x9265,0xD6AD,0xEEFF,
                  0x0800,0x0054,0x0200,0x00A1,0x4AA2,0x4095,0x5AF6,0xBBEF,
                  0x0000,0x4800,0x0000,0x0040,0x2488,0x9502,0xAB5D,0xEF7F,
                  0x0001,0x0114,0x0000,0x11A0,0x0122,0x205B,0xADB7,0x7BF7,
                  0x0090,0x2500,0x0000,0x45E0,0x0048,0x9521,0xD6DB,0x6DBF,
                  0x0804,0x8850,0x0800,0x0408,0x1802,0x2012,0xD375,0xDFEF,
                  0x22A0,0x3E00,0x4400,0x0206,0x9044,0x8AA3,0xB6AE,0xF6BF,
                  0x0008,0xB500,0x0000,0x00B0,0x0810,0x2089,0x6FB7,0x5BFF,
                  0xA442,0xAD00,0x0010,0x000B,0x0042,0x8450,0x7E6A,0xFF6F,
                  0x0015,0x5D00,0x4600,0x0401,0x5010,0x2289,0x7DBB,0xB7FF,
                  0xABAD,0xFC00,0x0104,0x000A,0x0085,0x1020,0x81E2,0xDB7F,
                  0x0176,0xA880,0x2901,0x0368,0x0050,0x848A,0x0AFB,0x7FDF,
                  0x5F5D,0xFC00,0x0140,0x0000,0x0002,0x5120,0x4DAE,0xE6FF,
                  0xABB7,0xB491,0x22D0,0x4000,0x0290,0x0092,0x165F,0xD7FF,
                  0xAEDE,0xFD80,0x0528,0x0000,0x0002,0x8820,0x8339,0xEF6F,
                  0xAAED,0xB780,0x0110,0x2800,0x5548,0x4289,0x03ED,0xBDFB,
                  0x4B76,0xFAC4,0x1110,0x0509,0x0021,0x0840,0x20EF,0x57FF,
                  0xD16F,0xF500,0x007D,0x0020,0x4908,0x0514,0x8655,0xAE7F,
                  0xAAEF,0xBFA4,0x11C0,0x4485,0x0022,0x5040,0x297A,0xB5B7,
                  0xF17A,0xF5D0,0x0206,0x8010,0x5500,0x8112,0x186D,0x57D6,
                  0xB55F,0xFDC4,0x0C00,0x4042,0x0048,0x1000,0x8D5A,0x986F,
                  0x7AFB,0xBFF0,0x8438,0x1404,0x9102,0x0552,0x05F5,0x6F2A,

                  0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
                  0xADFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
                  0xFF6F,0x7BFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
                  0xB7FD,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
                  0xFDB7,0xFDBF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
                  0xBFFF,0xB7FF,0xFFFF,0xFFFF,0xFFFD,0xBFFF,0xFFFF,0xFFFF,
                  0xF6DE,0xFFFB,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,
                  0x6FFB,0xFFFE,0xF7FF,0xFF5A,0xFFFE,0xDBFF,0xFFFF,0xFFFF,
                  0xDD6F,0xAFEF,0xFFFF,0xFFFF,0xDFFF,0xFFFF,0xFFFF,0xFFFF,
                  0xFFFE,0xFDBF,0xFFFF,0xFFD7,0x7FFD,0xAFFF,0xFFFF,0xFFFF,
                  0x556D,0xFFFF,0xFFFF,0xFDBD,0xF7FF,0xFAFF,0xFFFF,0xFFFF,
                  0xFFFF,0xEFFF,0xFFFF,0xEBED,0xBDFA,0xDFFF,0xFFFF,0xFFFF,
                  0x6BB7,0xBEFF,0xFFD5,0xBEBB,0xEFFF,0xF5FF,0xFFFF,0xFFFF,
                  0xDEFE,0xFFFE,0xFFBF,0xFBDE,0xB7FE,0xB6BF,0xFFFF,0xFFFF,
                  0xBBDF,0xFBDB,0xFEFF,0xEEFB,0x7AEF,0xDFFF,0xFFFF,0xFFFF,
                  0xF6F7,0xFFFF,0xFFEF,0xBB57,0xD7BD,0x6ABF,0xFFFF,0xFFFF,
                  0xAFBF,0xFF7F,0xFBBE,0xFDFA,0xBAFF,0xBF6F,0xFFFF,0xFFFF,
                  0xBBFD,0xBDFF,0xFDFF,0xEDAE,0xD775,0xEAF7,0xFFFF,0xFFFF,
                  0xFEEF,0xFFFF,0xFF5A,0xB755,0xBBBF,0x6FAF,0xFFFF,0xFFFF,
                  0xAFFD,0xFFFF,0xEDAD,0xFAF7,0x5555,0xBADB,0xFFFF,0xFFFF,
                  0xFAEF,0xFFFF,0xDB77,0x2B5D,0x7DF7,0xED6F,0xFFFF,0xFFFF,
                  0xBFBF,0xFDFF,0xBDDD,0x56AA,0xCAAD,0x775B,0xFFFF,0xFFFF,
                  0xEDFF,0xBFFF,0xEEF6,0xFBAB,0x775B,0xBBDA,0xFFFF,0xFFFF,
                  0xBFFF,0xFFFF,0x7DAD,0x4AF5,0xADB5,0xD66D,0xFFFF,0xFFFF,
                  0xF777,0xFFFF,0xAEAB,0x6D2E,0xB6DA,0xFBAA,0xFFFF,0xFFFF,
                  0xDFFF,0xFFFE,0xDADE,0xB5B2,0xAAAE,0xAD5B,0x7FFF,0xFFFF,
                  0xFFFF,0xFFFD,0x6F6B,0xD55E,0xD575,0x7ED5,0x7FFF,0xFFFF,
                  0xBEFF,0xFFFA,0xF9AD,0x6EA9,0x7BAD,0xD5BD,0x7FFF,0xFFFF,
                  0xF7FF,0xFFFA,0xAD5D,0xB356,0xAAB6,0xBECA,0xBFFF,0xFFFF,
                  0xFFFF,0xFFED,0x56EF,0xDDBB,0x555B,0x55B5,0xDFFF,0xFFFF,
                  0xFFFF,0xFFEA,0xD537,0x6AD5,0xB6D7,0xB6DA,0x5FFF,0xFFFF,
                  0xFFFF,0xFFEA,0xAEDF,0xDB55,0x5559,0xEB57,0xBFFF,0xFFFF,
                  0xFFFF,0xFFAD,0x757F,0xF6DA,0xEB56,0x76AC,0xCFFF,0xFFFF,
                  0xFFFF,0xFFD2,0x95AF,0xFF6B,0x555B,0xAB5A,0x5FFF,0xFFFF,
                  0xFFFF,0xFFAA,0xAEFF,0xEAB5,0x5B6D,0xFD6B,0x57FF,0xFFFF,
                  0xFFFF,0xFFB5,0x536B,0xFDDA,0xEDBB,0xEAB5,0x67FF,0xFFFF,
                  0xFFFF,0xFFAA,0xADFF,0xFFAF,0xB7FF,0x55D5,0x57FF,0xFFFF,
                  0xFFFF,0xFFA4,0xA576,0xFEFF,0xBFF7,0x6AAA,0xA7FF,0xFFFF,
                  0xFFFF,0xFF12,0xBBFD,0xFFB7,0xF5FE,0xDEAD,0x57FF,0xFFFF,
                  0xFFFF,0xFE55,0x557B,0x7FFF,0x7FFF,0x6955,0x53FF,0xFFFF,
                  0xFFFF,0xFEA4,0xABFD,0xFFFF,0x7FFD,0xD6AA,0x97FF,0xFFFF,
                  0xFFFF,0xFE93,0x5DFB,0x7FFD,0xFFEF,0x5574,0x53FF,0xFFFF,
                  0xFFFF,0xFE94,0xAFDE,0xFFF6,0xBFFF,0xB795,0x48DD,0xFFFF,
                  0xFFFF,0xFEAA,0xAF7F,0x7DA8,0x57F7,0xD452,0xAB7F,0xBFFF,
                  0xFFFF,0xFAA5,0x5FFD,0xBA80,0x17FF,0x6BAA,0xA9EE,0xFFFF,
                  0xFFFF,0xDA52,0xBFFF,0xF800,0x0FFF,0xDAB4,0x45BB,0xDBFF,
                  0xFFFF,0x754B,0x7FFF,0x7A00,0x0FFF,0xEAD5,0x54EF,0x7FFF,
                  0xFFFD,0xA8AA,0xFDFB,0xF800,0x0FFF,0xBB25,0x57B5,0xDBFF,
                  0xFF5B,0x5025,0xDFFF,0xF400,0x03FE,0xD552,0x895B,0x6FFF,
                  0xFDFA,0xA156,0xBFFF,0xF000,0x17FD,0xF68A,0x54ED,0xBD7F,
                  0xF724,0x5089,0x7BF5,0xD000,0x037F,0x55AA,0x949B,0x6BFF,
                  0xFDB0,0x90B6,0xBDFA,0xC800,0x03FD,0xDAA9,0x4AAD,0xBFBF,
                  0xD64A,0x414A,0xAFFA,0xB410,0x15F7,0x6AA4,0x216A,0xAAEF,
                  0xF5A5,0x20A5,0x7BEA,0xB210,0x81FE,0xAAA5,0x95AA,0xDDBF,
                  0x4A50,0x02B5,0x5FFF,0xF028,0x20BF,0xDAB2,0x5555,0x56EF,
                  0xA900,0x2145,0x6BFE,0x8002,0x127A,0xAAA9,0x11A4,0x15BB,
                  0x5200,0x0129,0x5FF5,0x4000,0x807F,0x6A94,0xAAD2,0xAADE,
                  0x0800,0x02A5,0x7FFA,0x0002,0x407F,0xAA65,0x2982,0x46B7,
                  0x8200,0x1592,0x2FD5,0x0000,0x023F,0x7DAA,0xAB89,0x55AD,
                  0x1000,0x05D5,0xBFE8,0x0000,0x003F,0xEA91,0x2980,0x94DB,
                  0x0000,0x0152,0xFFA0,0x0000,0x4077,0xFEAA,0xA952,0x5577,
                  0x0000,0x05AC,0xBF48,0x0000,0x001F,0xF754,0x2A01,0x254D,
                  0x0000,0x01D3,0x7FA4,0x0000,0x2217,0xFDAA,0xA0A2,0x00B6,
                  0x0000,0x4DAA,0xFFFF,0xD000,0x403F,0xFEA5,0x2C10,0x8A15,
                  0x0005,0x0BAA,0xFFFF,0xFBFD,0xDE9F,0xE294,0xA220,0x0296,
                  0x0150,0xABEB,0xFFFF,0xCDFE,0xB5FF,0x5AAA,0x1800,0x1451,
                  0x040A,0x5BE9,0x7FFD,0xF55F,0xFFF5,0x556B,0xD602,0x02A5,
                  0x1155,0x23F6,0xFFFD,0xDAEF,0xF7D4,0xAAAA,0x2800,0x082A,
                  0x48A4,0x97EB,0xEFEA,0x355B,0x172A,0xAAAB,0xA804,0x002B,
                  0x2512,0x57DD,0x73F5,0x16AE,0x2EC4,0x2AAC,0xA800,0x0015,
                  0x12D5,0x54AD,0xF1D4,0x7BFE,0x0EAF,0xAAAA,0xA804,0x0824,
                  0xAA5A,0xA995,0xF05E,0xE5FC,0x0550,0x5D57,0x5200,0x000A,
                  0x4AAA,0xAEB5,0xD01C,0x1DE0,0x0EAD,0xBD5A,0xB000,0x0480,
                  0x5555,0x6AFD,0xE084,0x1FC0,0x0EBF,0xFDAD,0x5A00,0x0008,
                  0xAAAD,0xABE5,0xD081,0x7FC0,0x0EAF,0xD6EF,0xD000,0x0004,
                  0xAB76,0xB765,0xE005,0xFD00,0x86DF,0xFB59,0x5600,0x0002,
                  0x76AD,0x56E5,0xC000,0x4580,0x0E7F,0x55EE,0xA400,0x0001,
                  0x9BDB,0x6BCF,0xB400,0x0200,0x0F57,0xF6BB,0x6000,0x0000,
                  0xED6D,0xBD43,0xD000,0x040C,0x0D5F,0xFDF6,0xB100,0x0054,
                  0x57B6,0xD7AD,0xC800,0x0008,0x0EAF,0xFFFA,0xAC10,0x0000,
                  0xFAFB,0x7AC5,0xF400,0x0001,0x2F6B,0xFFEE,0xD440,0x0004,
                  0xAFDD,0xADCF,0xF400,0x0000,0x9EB7,0x7FFA,0xA000,0x0002,
                  0xFAAF,0xF7F9,0xF540,0x0006,0x4F9B,0xEFCB,0x4A48,0x0000,
                  0xDFFA,0xBABD,0xFB20,0x000F,0x2ED7,0xFDBD,0x5801,0x0002,
                  0xB56F,0xDDED,0xF5C8,0x001F,0x9F5D,0xFF6A,0x5128,0x0000,
                  0xFFDA,0xF77D,0xBEA8,0x001C,0x0FAF,0xF5D5,0xA480,0x1000,
                  0xB77F,0xBDD9,0xFAB5,0x0031,0x0355,0xFF5A,0x4022,0x4002,
                  0xFDF7,0xD7FB,0xFFD8,0x0075,0x83AB,0xBFEC,0x6A88,0x0010,
                  0xEFDE,0xFEAF,0xFD58,0x006B,0x0AB7,0xF556,0xC120,0x0002,
                  0xBEFF,0xB7FC,0xFFF2,0x001F,0xFEAB,0xFEEA,0xA809,0x2400,
                  0xFBF5,0xFD6D,0xEDA8,0x0010,0xFD57,0xFBAC,0x92A0,0x0080,
                  0xFFDF,0xDFFE,0xFFF8,0x000B,0xEA5A,0xFEB7,0xA40A,0x0800,
                  0xFF7F,0x7FBE,0xFFF8,0x0000,0x75AB,0xFBA9,0x4940,0x8000,
                  0xEFFF,0xF6F6,0xFF94,0x0000,0x3EB7,0xFD6C,0x9214,0x1000,
                  0xFFFF,0xFFDF,0x7EE8,0x0000,0x1EDF,0xF6B8,0x4889,0x4100,
                  0xFFFB,0x7DFF,0xFF54,0x0000,0x27EF,0xFFAD,0x2450,0x1400,
                  0xFFFF,0xF7FF,0xFFFE,0x0000,0x21BF,0xF551,0x9284,0x8040,
                  0xFB6F,0xDFFF,0xFFFA,0x0000,0x03FA,0xEEFB,0x5520,0x2800,
                  0xEFFF,0x7FDF,0xBFFA,0xA781,0x87EF,0xFB49,0x248A,0x8200,
                  0xFFFF,0xFFFF,0xFFFA,0xBEA7,0xFFFA,0xD6D9,0x5240,0x2880,
                  0xFFFD,0xFFFF,0xFFFF,0xFDEF,0xF55D,0xBB62,0xA92A,0x8020,
                  0xFFFF,0xFFBF,0xFFFB,0x7355,0x5AEA,0xEDB2,0x5488,0x2480,
                  0xFFFF,0xFFFF,0xFFFF,0xFDFF,0xEEAD,0xDB66,0x8252,0x9000,
                  0xFFFF,0xFFF9,0xFFF7,0xFDF8,0x1DD7,0x6DA2,0x6A88,0x4490,
                  0xFFFD,0xFB79,0xFFFF,0xFBFC,0xFFED,0xDEF5,0x14A5,0x1000,
                  0xFFF7,0xFFE9,0xFFFF,0xF5FF,0xFF5B,0x6B8A,0xD248,0x82A0,
                  0xFFDF,0xEDF9,0xFFFF,0xF5FF,0xFDEF,0x6D9A,0x2952,0x1100,
                  0xF7FF,0xFFB7,0xFDFF,0xFEFE,0xB55D,0xBF4A,0xA509,0x4410,
                  0xFFFF,0xB7E7,0xFFFF,0xFEFF,0xDB77,0x6AC5,0x54A2,0x1080,
                  0xFFFE,0xFEFF,0xFFFF,0xFFFF,0xFEDD,0xDFBA,0x5248,0x8408,
                  0xFF6F,0xDBEF,0xFFFF,0xFFF7,0xFFB7,0x6AD9,0x2924,0x9240,
                  0xF7FB,0x77FF,0xFFFF,0xFEDA,0xBFFD,0xDFEE,0xDC8A,0x2010,
                  0xDD5F,0xC1FF,0xFFFF,0xFF66,0xBFBB,0x755D,0xBD51,0x0940,
                  0xFFF7,0x4AFF,0xF5FF,0xFDF5,0x5FEF,0xDF76,0x6E48,0xA400,
                  0x5BBD,0x52FF,0xFFEF,0xFE9B,0xFFBD,0x7BAF,0xFF95,0x0090,
                  0xFFEA,0xA2FF,0xF7FF,0xFEAB,0xFFEF,0xDD76,0xBDE4,0x4800,
                  0x5452,0x03FF,0xFF7B,0xFF7F,0xFF7A,0xEFDF,0x7FF9,0x2480,
                  0xFE89,0x577F,0xFDFE,0xFFEF,0xFFAF,0x7B75,0xFFFE,0x8020,
                  0xA0A2,0x03FF,0xFFFF,0xFFFF,0xFFFD,0xAEDF,0xBFFF,0x9900,
                  0x5448,0x4A6E,0xF7FF,0xBFFF,0xFD6F,0xFF6D,0xEFFF,0xF000,
                  0x5121,0x027F,0xFFFF,0xFFFF,0xFFFD,0x77DF,0x7FFD,0xFC90,
                  0x5512,0x48FF,0xFFFF,0xD7FF,0xAAB7,0xBD76,0xFFFD,0xFF84,
                  0xB489,0x05BB,0xFBBB,0xFAF6,0xFFDE,0xF7BF,0xDFFF,0x57E0,
                  0x2E90,0x0A7F,0xFFFF,0xFFDF,0xB6F7,0xFAEB,0x7FF7,0xAEF8,
                  0x5510,0x405B,0xFBED,0xFB7A,0xFFDD,0xAFBF,0xDFFA,0xB5BE,
                  0x0E85,0x0A6F,0xFFB7,0xFFEF,0xAAFF,0x7EED,0xEFED,0x17D7,
                  0x4AA0,0x023B,0xFEDA,0xFFBD,0xFFB7,0xEFFF,0x7FFA,0x106F,
                  0x8504,0x400F,0x7F7F,0x5FFB,0x6EFD,0xFAAD,0xFFFC,0x4B2A,

                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x8000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0000,0x8000,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0002,0x0010,0x0000,0x0000,0x0000,
                  0x0000,0x0000,0x0000,0x0009,0x4000,0x0000,0x0122,0x0000,
                  0x0000,0x0000,0x0000,0x0257,0xA808,0x0000,0x0080,0x4000,
                  0x0000,0x0400,0x0000,0x057F,0xE800,0x0000,0x0011,0x0000,
                  0x0000,0x2400,0x0000,0x07FF,0xF000,0x0000,0x0044,0x2400,
                  0x0000,0x8800,0x0000,0x05FF,0xF000,0x0000,0x0010,0x8000,
                  0x0002,0x5400,0x0004,0x07FF,0xF000,0x0000,0x004A,0x2400,
                  0x00A4,0xAC00,0x0000,0x0BFF,0xFC00,0x0000,0x00A4,0x9000,
                  0x0205,0x5C00,0x0000,0x0FFF,0xE800,0x0000,0x0012,0x4280,
                  0x08DB,0xAC00,0x000A,0x2FFF,0xFC80,0x0000,0x0064,0x9400,
                  0x024F,0x6C00,0x0005,0x37FF,0xFC00,0x0000,0x0052,0x4040,
                  0x29B5,0xBC00,0x0005,0x4BEF,0xEA00,0x0000,0x0095,0x5510,
                  0x0A5A,0xDC00,0x0015,0x4DEF,0x7E00,0x0000,0x0055,0x2240,
                  0xB5AF,0xFC00,0x0000,0x0FD7,0xDF00,0x0000,0x00AA,0xA910,
                  0x56FF,0xDC00,0x0001,0x7FFD,0xED80,0x0000,0x005B,0xEA44,
                  0xADFF,0xFC00,0x000A,0xBFFF,0x7F80,0x0000,0x002D,0x5521,
                  0xF7FF,0xFC00,0x0005,0xFFFD,0xBF80,0x0000,0x007D,0xB948,
                  0x7DFF,0xE800,0x002A,0xFFFF,0xFDC0,0x0000,0x0076,0xAA52,
                  0xEFFF,0xF800,0x0017,0xFFFF,0xFFC0,0x0000,0x007F,0x6B24,
                  0xFFFF,0xFC00,0x005F,0xFFFF,0xBF88,0x0000,0x00AD,0xAA88,
                  0xFFFF,0xF800,0x00B7,0xFFFF,0xFFE0,0x0000,0x01FE,0xDAB2,
                  0xFFFF,0xFC00,0x005B,0xFFFF,0xDDE8,0x0000,0x015D,0xFF49,
                  0xFFFF,0xF000,0x0000,0x2FFF,0xBFC0,0x0000,0x01EF,0x75EA,
                  0xFFFF,0xF000,0x0000,0x0002,0x2160,0x0000,0x01DF,0xFD69,
                  0xFFFF,0xF000,0x0000,0x0001,0x4A00,0x0000,0x01FF,0xEBAE,
                  0xFFFF,0xF000,0x0002,0x0000,0x0000,0x0000,0x01FD,0xFD5A,
                  0xFFFF,0xF800,0x0000,0x0000,0x0800,0x0000,0x03FF,0xF7D5,
                  0xFFFF,0xFC00,0x1000,0x0000,0xE800,0x0000,0x03FB,0xFFD4,
                  0xFFFF,0xFC20,0x0C00,0xA001,0xD000,0x0000,0x03FF,0xFFEA,
                  0xFFFF,0xFE50,0x0E03,0x8001,0xF000,0x0000,0x03FB,0xF7DB,
                  0xFFFF,0xFE68,0x0FA1,0xC203,0xF806,0x0000,0x03FF,0xFFF5,
                  0xFFFF,0xFE48,0x2FE3,0xE21F,0xF002,0x0000,0x03FF,0xFB7F,
                  0xFFFF,0xFE00,0x1F7B,0xE03F,0xF000,0x0000,0x03FF,0xFFF7,
                  0xFFFF,0xFE18,0x2F7E,0x803F,0xF000,0x0000,0x03FF,0xFFFB,
                  0xFFFF,0xFE18,0x1FFA,0x02FF,0x7800,0x0000,0x03FF,0xFFFD,
                  0xFFFF,0xFF18,0x3FFF,0xBA7F,0xF000,0x0000,0x03FF,0xFFFE,
                  0xFFFF,0xFF30,0x4BFF,0xFDFF,0xF000,0x0000,0x07FF,0xFFFF,
                  0xFFFF,0xFFB8,0x2FFF,0xFBF3,0xF000,0x0000,0x07FF,0xFFAB,
                  0xFFFF,0xFF90,0x37FF,0xFFF7,0xF000,0x0000,0x07FF,0xFFFF,
                  0xFFFF,0xFF98,0x0BFF,0xFFFE,0xD000,0x0000,0x0FFF,0xFFFB,
                  0xFFFF,0xFFE0,0x0BFF,0xFFFF,0x6000,0x0000,0x0FFF,0xFFFD,
                  0xFFFF,0xFFF8,0x0ABF,0xFFF9,0xB000,0x0000,0x0FFF,0xFFFF,
                  0xFFFF,0xFFF8,0x04DF,0xFFF0,0xD000,0x0000,0x0FFF,0xFFFD,
                  0xFFFF,0xFFF8,0x0A37,0xFFE0,0x6000,0x0000,0x3FFF,0xFFFF,
                  0xFFFF,0xFFF8,0x0157,0xFFE3,0xF000,0x0000,0x7FFF,0xFFFF,
                  0xFFFF,0xFFFC,0x054A,0xFFCE,0xFC00,0x0000,0xFFFF,0xFFFD,
                  0xFFFF,0xFFFC,0x0027,0xFF8A,0x7C00,0x0000,0xFFFF,0xFFEF,
                  0xFFFF,0xFFFC,0x02A7,0xFF94,0xF400,0x0000,0xFFFF,0xFFFD,
                  0xFFFF,0xFFFE,0x000D,0xFFE0,0x0000,0x0000,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0257,0xFFE0,0x0000,0x0000,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0007,0xFFF0,0x0000,0x0000,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0007,0xFFFF,0x8000,0x0000,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x006B,0xFFFF,0xC000,0x0001,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0117,0xFFFF,0xE000,0x0001,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x00AB,0xFFFF,0xD800,0x0001,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0001,0xFFFF,0xDE00,0x0001,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0005,0xFFFF,0xFC00,0x0001,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0005,0x587E,0x7800,0x0003,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0005,0x4158,0x0000,0x0003,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0000,0x0000,0x0000,0x0007,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0004,0x8000,0x0000,0x0007,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0000,0x0200,0x0000,0x0007,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0008,0x0207,0xE200,0x000F,0xFFFF,0xFFFF,
                  0xFFFF,0xFFFE,0x0000,0x0403,0x0000,0x000F,0xFFFF,0xFFFF,
                  0xFFFF,0xFFF6,0x0000,0x0A00,0x0000,0x001F,0xFFFF,0xFFFF,
                  0xFFFF,0xFFE6,0x0000,0x0A00,0x0000,0x001F,0xFFFF,0xFFFF,
                  0xFFFF,0xFFC8,0x0000,0x0100,0x0000,0x003F,0xFFFF,0xFFFF,
                  0xFFFF,0xFF98,0x0000,0x0100,0x0000,0x003F,0xFFFF,0xFFFF,
                  0xFFFF,0xFF00,0x0000,0x0000,0x0000,0x0005,0xFFFF,0xFFFF,
                  0xFFFF,0xFE10,0x0000,0x0008,0x0000,0x0006,0xFFFF,0xFFFF,
                  0xFFFF,0xFE00,0x0000,0x0125,0x4000,0x0001,0x2FFF,0xFFFF,
                  0xFFFF,0xFE00,0x0000,0x0099,0x4000,0x0000,0x43FF,0xFFFF,
                  0xFFFF,0xFE00,0x0A00,0x020A,0xA000,0x0000,0x91FF,0xFFFF,
                  0xFFFF,0xFE00,0x0000,0x0164,0x0000,0x0000,0x007F,0xFFFF,
                  0xFFFF,0xFE00,0x0800,0x0154,0x0000,0x0000,0x021F,0xFFFF,
                  0xFFFF,0xFE00,0x0080,0x0080,0x0000,0x0000,0x0007,0xFFFF,
                  0xFFFF,0xFE00,0x0200,0x0010,0x0000,0x0000,0x0001,0xFFFF,
                  0xFFFF,0xFE00,0x0000,0x0000,0x0000,0x0000,0x0000,0x7FFF,
                  0xFFFF,0xFF00,0x0800,0x0000,0x0000,0x0000,0x0000,0x0FFF,
                  0xFFFF,0xFF00,0x0000,0x0000,0x0000,0x0000,0x0002,0x03FF,
                  0xFFFF,0xFF00,0x0000,0x0000,0x0000,0x0000,0x0002,0x007F,
                  0xFFFF,0xFF00,0x0444,0x0000,0x0000,0x0000,0x0000,0xA81F,
                  0xFFFF,0xFF80,0x0000,0x0000,0x0000,0x0000,0x0008,0x5107,
                  0xFFFF,0xFF80,0x0412,0x0000,0x0000,0x0000,0x0005,0x4A41,
                  0xFFFF,0xFF80,0x0048,0x0000,0x0000,0x0000,0x0012,0xE828,
                  0xFFFF,0xFFC0,0x0125,0x0000,0x0000,0x0000,0x0005,0xEF90,
                  0xFFFF,0xFFE0,0x0080,0xA000,0x0000,0x0000,0x0003,0xB4D5};

/*----------------------------------------------------------------------------*/

/* End of Text */
