#ifndef LIBRARIES_RUNBAR_H
#define LIBRARIES_RUNBAR_H

/*
**	$VER: RunBar.h 1.0 (24.11.96)
**	Includes Release 1.0
**
**	RunBar.library interface structures and definitions.
**
**	(C) Copyright 1996 Sergej Kravcenko
**	All Rights Reserved
*/

/*****************************************************************************/


#ifndef EXEC_TYPES_H
#include <exec/types.h>
#endif

#ifndef EXEC_TASKS_H
#include <exec/tasks.h>
#endif

#ifndef EXEC_PORTS_H
#include <exec/ports.h>
#endif

#ifndef INTUITION_INTUITION_H
#include <intuition/intuition.h>
#endif

/*****************************************************************************/


/* structure for use with RB_GetTList() */
struct SBItem
{
    ULONG sbi_Type;/*  0-Normal       */
                   /*  1-Disabled     */
                   /*  2-Bar          */
                   /*  F-END          */
    char  *sbi_Name;
};
/* RunBar Message structure */
struct RBMessage
{
    struct Message rb_Msg;
    ULONG          rb_class; /* See IDCMP */
    ULONG          rb_code;  /* see Commands */
};
struct RBInfo
{
    BYTE           rb_Version; /*Always set it to RB_VERSION*/
    char           *rb_Name;   /*Task Name*/
    ULONG          rb_Flags;
};

/****************RBInfo Flags********************/

#define RBF_DUPLICATE 0
#define RBF_UNIQUE 1

/*************Version*************/

#define RB_VERSION 1

/***********Errors**********/

#define RB_NORUNBAR 1  /* RunBar is not running */
#define RB_MAXITEM  2  /* Cannot add more that 15 items */
#define RB_UNIQUE   3  /* Program already exists */
#define RB_TASK     4  /* Task pointer error */
#define RB_PORT     5  /* Cannot allocate message port */ 

/*****************************************************************************/


/* Messages */
#define RB_REMOVE       0 /* Remove message */

/*IDCMP*/

#define IDCMP_RUNBARCMD 0x80800000 /*RunBar command*/
#define IDCMP_RUNBARMSG 0x80800001 /*RunBar message*/

/*****************************************************************************/



#endif /* LIBRARIES_RUNBAR_H */

